/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2004 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
*-------------------------------------------------------------------------------
*
*   Aware DMT Technology. Proprietary and Confidential.
*
*   40 Middlesex Turnpike, Bedford, MA 01730-1413
*   Phone (781) 276 - 4000
*   Fax   (781) 276 - 4001
*
*   filename: ftb_io_typedef.h
*
*   This file contains Iridia-FTB I/O type definitions used by other BMs.
*
*-------------------------------------------------------------------------------
*/

#ifndef _FTB_IO_TYPEDEF_H
#define _FTB_IO_TYPEDEF_H


// Structure used for Iridia-QT input signals
typedef struct {

      // IRI_FTB_TX

   // IRI_FDF INTERFACE
   uint8 uc_FDF_IFFT_FRAME[4];

   // IRI_QT INTERFACE
   uint8 uc_QT_TX_BUFFER_SWAP[4];

   // IRI_FT INTERFACE
   uint8 uc_FT_TX_BUFFER_SWAP[4];


   // IRI_FTB_RX

   // IRI_FDF INTERFACE
   uint8 uc_FDF_FFT_FRAME[4];

   // IRI_QT INTERFACE
   uint8 uc_QT_RX_BUFFER_SWAP[4];

   // IRI_FT INTERFACE
   uint8 uc_FT_RX_BUFFER_SWAP[4];


} IridiaFTB_Input_t;


// Structure used for Iridia-FTB output signals
typedef struct {

   // IRI_FTB_TX

   //CRI INTERFACE
   uint8 uc_TX_FRAME[4];

   // IRI_QT INTERFACE
   uint8 uc_QT_TX_STALL[4];

   // IRI_FT INTERFACE
   uint8 uc_FT_TX_STALL[4];

   // IRI_FTB_RX

   //CRI INTERFACE
   uint8 uc_RX_FRAME[4];

   // IRI_QT INTERFACE
   uint8 uc_QT_RX_STALL[4];

   // IRI_FT INTERFACE
   uint8 uc_FT_RX_FFT_START[4];



} IridiaFTB_Output_t;




#endif // _FTB_IO_TYPEDEF_H
