/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2004 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
*-------------------------------------------------------------------------------
*
*   Aware DMT Technology. Proprietary and Confidential.
*
*   40 Middlesex Turnpike, Bedford, MA 01730-1413
*   Phone (781) 276 - 4000
*   Fax   (781) 276 - 4001
*
*   filename: qt_io_typedef.h
*
*   This file contains Iridia-QT I/O type definitions used by other BMs.
*
*-------------------------------------------------------------------------------
*/

#ifndef _QT_IO_TYPEDEF_H
#define _QT_IO_TYPEDEF_H



#ifndef _BASIC_TYPES
#define _BASIC_TYPES

#include <stdio.h>

#ifdef UNIX_PLATFORM
#include "svdpi.h"
#endif

typedef void  (*PtrToFunc)(void);
/* Variable type definitions */
typedef double float64;          /* prefix d in hungarian notation */
typedef long  int32;             /* prefix l */
typedef char  int8;              /* prefix c */
typedef short int16;          /* prefix s */
typedef unsigned char uint8;     /* prefix uc */
typedef unsigned long uint32;    /* prefix ul */
typedef unsigned short uint16;      /* prefix us */
typedef unsigned long Float32;      /* prefix f */
typedef unsigned char FlagT;     /* prefix ft */

#endif // _BASIC_TYPES

// Structure used for Iridia-QT input signals
typedef struct {

   // IRI_QT_TX
   uint8 uc_TX_GO[4];

   // IRI_QT_RX
   uint8 uc_RX_GO[4];

} IridiaQT_Input_t;
extern IridiaQT_Input_t gt_IridiaQT_Input;


// Structure used for Iridia-QT output signals
typedef struct {

   // IRI_QT_TX
   uint8 uc_TX_DONE[4];
   uint8   uc_TX_BATERR[4];
   uint16   us_TX_SIZE0[4];
   uint16   us_TX_SIZE1[4];

   // IRI_QT_RX
   uint8 uc_RX_DONE[4];
   uint8   uc_RX_BATERR[4];
   uint16   us_RX_SIZE0[4];
   uint16   us_RX_SIZE1[4];

} IridiaQT_Output_t;

extern IridiaQT_Output_t gt_IridiaQT_Output;


#endif // _QT_IO_TYPEDEF_H
