/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2004 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
*-------------------------------------------------------------------------------
*
*   Aware DMT Technology. Proprietary and Confidential.
*
*   40 Middlesex Turnpike, Bedford, MA 01730-1413
*   Phone (781) 276 - 4000
*   Fax   (781) 276 - 4001
*
*   filename: QTP_cocomo_interface.h
*
*   This file Specifies the Cocomo to Iridia-QTP interface.  This interface
*  includes the register read/write functions, core reset functions, BM
*  intialization functions, and any other cocomo/BM only functions/variables
*  that are required to run a HW Engine simulation.  These functions are NOT
*  required by, and unavailable for, actual HW.
*
*-------------------------------------------------------------------------------
*/

#ifndef _QTP_COCOMO_INTERFACE_H
#define _QTP_COCOMO_INTERFACE_H


#include "qtp_typedef.h"

//#include "qtp_io_typedef.h"


//=============================================================================
// Iridia-QTP BM clocking functions
//=============================================================================
void IRI_QTP_Clock(void);
void IRI_QTP_Clock_Tx_Frame(uint8 uc_port);
void IRI_QTP_Clock_Rx_Frame(uint8 uc_port);

//=============================================================================
// Iridia-QTP BM initialization functions
//=============================================================================
void IRI_QTP_InitializeBM(void);

//=============================================================================
// Iridia-QTP BM reset functions
//=============================================================================
void IRI_QTP_Reset(void);

int32 IRI_QTP_WriteWord(uint32 addr, uint32 ul_data, uint8 uc_ByteEnable,uint8 uc_port);
int32 IRI_QTP_ReadWord(uint32 addr, uint32 *pul_data, uint8 uc_ByteEnable,uint8 uc_port);

int32 IRI_QTP_GetExtendedGainTableAddress(uint8 **puc_BaseAddr, uint8 uc_port);
int32 IRI_QTP_GetToneReorderingTableAddress(uint16 **pus_BaseAddr,uint8 uc_port);
int32 IRI_QTP_GetGainScaleTableAddress(uint16 **pus_BaseAddr, uint8 uc_port);
int32 IRI_QTP_GetBitAllocationTableAddress(uint8 **puc_BaseAddr, uint8 uc_port);


extern int32 IRI_QT_GetActiveBGTNTableAddress(uint32 **pus_BaseAddr, int32 s_Path,uint8 uc_port);

extern int32 IRI_QT_GetActiveEGTTableAddress(uint8 **puc_BaseAddr, uint8 uc_port);


extern IridiaQTP_Input_t gt_IridiaQTP_Input;
extern IridiaQTP_Output_t gt_IridiaQTP_Output;



#endif // _QTP_COCOMO_INTERFACE_H
