/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
//------------------------------------------------------------
// Generated Register definition file for aec :: aec_cfg
//------------------------------------------------------------
#ifndef __aec_cfg_regdef__
#define __aec_cfg_regdef__

#include <regvr9.h>

//------------------------------------------------------------
// The register interface data structure
//------------------------------------------------------------

typedef struct {
   uint32 AEC_PROG_DLY_CTRL_PRGDEL;
   uint32 AEC_PROG_DLY_CTRL_INIT;
   uint32 AEC_PROG_DLY_CTRL_EN;
   uint32 AEC_PROG_FIR_CTRL_PRGDEL;
   uint32 AEC_PROG_FIR_CTRL_BP_F;
   uint32 AEC_PROG_FIR_CTRL_INIT;
   uint32 AEC_PROG_FIR_CTRL_EN;
   uint32 AEC_HP_CTRL_K;
   uint32 AEC_HP_CTRL_BP_F;
   uint32 AEC_HP_CTRL_INIT;
   uint32 AEC_HP_CTRL_EN;
   uint32 AEC_STATUS_HP_OVF[2];
   uint32 AEC_STATUS_PFIR_OVF[2];
   uint32 AEC_STATUS_AFIR_OVF[2];
} aec_cfg_reg_t;

aec_cfg_reg_t gt_aec_cfg_reg;

//------------------------------------------------------------
// The field definitions
//------------------------------------------------------------
fielddef_t AEC_PROG_DLY_CTRL[] = {
{ 7, 4, __REG_RW__ ,1,&(gt_aec_cfg_reg.AEC_PROG_DLY_CTRL_PRGDEL)},
{ 1, 1, __REG_RW__ ,1,&(gt_aec_cfg_reg.AEC_PROG_DLY_CTRL_INIT)},
{ 0, 0, __REG_RW__ ,1,&(gt_aec_cfg_reg.AEC_PROG_DLY_CTRL_EN)},
};
fielddef_t AEC_PROG_FIR_CTRL[] = {
{ 13, 8, __REG_RW__ ,1,&(gt_aec_cfg_reg.AEC_PROG_FIR_CTRL_PRGDEL)},
{ 4, 4, __REG_RW__ ,1,&(gt_aec_cfg_reg.AEC_PROG_FIR_CTRL_BP_F)},
{ 1, 1, __REG_RW__ ,1,&(gt_aec_cfg_reg.AEC_PROG_FIR_CTRL_INIT)},
{ 0, 0, __REG_RW__ ,1,&(gt_aec_cfg_reg.AEC_PROG_FIR_CTRL_EN)},
};
fielddef_t AEC_HP_CTRL[] = {
{ 11, 8, __REG_RW__ ,1,&(gt_aec_cfg_reg.AEC_HP_CTRL_K)},
{ 4, 4, __REG_RW__ ,1,&(gt_aec_cfg_reg.AEC_HP_CTRL_BP_F)},
{ 1, 1, __REG_RW__ ,1,&(gt_aec_cfg_reg.AEC_HP_CTRL_INIT)},
{ 0, 0, __REG_RW__ ,1,&(gt_aec_cfg_reg.AEC_HP_CTRL_EN)},
};
fielddef_t AEC_STATUS[] = {
{ 16, 16, __REG_LHSC__ ,2,&(gt_aec_cfg_reg.AEC_STATUS_HP_OVF[0])},
{ 8, 8, __REG_LHSC__ ,2,&(gt_aec_cfg_reg.AEC_STATUS_PFIR_OVF[0])},
{ 0, 0, __REG_LHSC__ ,2,&(gt_aec_cfg_reg.AEC_STATUS_AFIR_OVF[0])},
};
//------------------------------------------------------------
// The Register list definitions
//------------------------------------------------------------
regdef_t aec_cfg[]={
   {0x00000001,0x00000001, AEC_PROG_DLY_CTRL, 3, 0x000000f3},
   {0x00000001,0x00000001, AEC_PROG_FIR_CTRL, 4, 0x00003f13},
   {0x00000601,0x00000601, AEC_HP_CTRL, 4, 0x00000f13},
   {0x00000000,0x00000000, AEC_STATUS, 3, 0x00010101},
};

//------------------------------------------------------------
// The Register ID definitions
//------------------------------------------------------------
#define n_aec_cfg_reg 4
#define AEC_PROG_FIR_CTRL_id 1
#define AEC_STATUS_id 3
#define AEC_HP_CTRL_id 2
#define AEC_PROG_DLY_CTRL_id 0
//------------------------------------------------------------
// The Special register/field definitions per clksync
//------------------------------------------------------------

fieldlistdef_t aec_cfg_clksync_lst[]={
{AEC_STATUS_id,0,__REG_LHSC__},
{AEC_STATUS_id,1,__REG_LHSC__},
{AEC_STATUS_id,2,__REG_LHSC__},
};
#define n_aec_cfg_clksync_lst 3
//------------------------------------------------------------
// The Special register/field definitions for multibuffered registers
//------------------------------------------------------------

//------------------------------------------------------------
// The Special register/field definitions for write once after reset type
//------------------------------------------------------------

//------------------------------------------------------------
// The Register ID to address map
//------------------------------------------------------------
addrdef_t aec_cfg_reg_ad_map[] = {
{"AEC_PROG_FIR_CTRL",0x0007d004, 1}, //AEC_PROG_FIR_CTRL_id
{"AEC_STATUS",0x0007d00c, 3}, //AEC_STATUS_id
{"AEC_HP_CTRL",0x0007d008, 2}, //AEC_HP_CTRL_id
{"AEC_PROG_DLY_CTRL",0x0007d000, 0}, //AEC_PROG_DLY_CTRL_id
};

//------------------------------------------------------------
// Table of Sync Event
//------------------------------------------------------------
//------------------------------------------------------------
// Register access Convenience functions
//------------------------------------------------------------

#define aec_cfg_reg_HW_reset                      reg_hwreset(aec_cfg, n_aec_cfg_reg,NULL,0)
#define aec_cfg_reg_SW_reset                      reg_swreset(aec_cfg, n_aec_cfg_reg)
#define aec_cfg_reg_read(addr,do_ptr,rmask,ch_id) reg_read(aec_cfg,aec_cfg_reg_ad_map,n_aec_cfg_reg,addr,do_ptr,rmask)
#define aec_cfg_reg_write(addr,di,wmask,ch_id)    reg_write(aec_cfg,aec_cfg_reg_ad_map,n_aec_cfg_reg,addr,di,wmask)
#define aec_cfg_reg_clksync(ch_id)                reg_clksync(aec_cfg,aec_cfg_clksync_lst,n_aec_cfg_clksync_lst)
#define aec_cfg_reg_eventsync(ch_id)


#endif
