/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright Infineon Technologies
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
//------------------------------------------------------------
// States and other definitions for aec :: aec_hp (highpass) and aec_pdel (prog. delay)
//------------------------------------------------------------
//------------------------------------------------------------
// All rights reserved. No part of this file shall be modified without notifying the owner.
//------------------------------------------------------------
//------------------------------------------------------------
// Author           : David Schwingshackl
// Created On       : December 2008
// Last Modified By : $Author: yangcao $
// Last Modified On : $Date: 2009/01/14 16:52:42Z $
//
// $Log: aec_cfg_states.h $
// Revision 1.1  2009/01/14 16:52:42Z  yangcao
// Initial revision
//
//------------------------------------------------------------


#ifndef __aec_cfg_statesdef__
#define __aec_cfg_statesdef__

#include <regvr9.h>


#define HP_WL_ACC 21
#define PDEL_DLY_MAX 15


//------------------------------------------------------------
// The states structure
//------------------------------------------------------------

typedef struct {
  int64 S;  // for HP (first-order)
  int16 U[PDEL_DLY_MAX+1];  // for programmable delay
  int16 s_idx_u;
} aec_cfg_states_t;


#endif
