/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright 1998-2007 (c) Aware, Inc.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//--
//
// The software is owned by Aware, Inc. and is protected by United States
// copyright laws and international treaty provisions. Therefore, you must treat
// the software like any other copyrighted material.  You may not use or copy
// the software or any accompanying written materials for any other purpose than
// what is described in the Development and License Agreement
// entered into with Aware Inc. (the "Agreement").  Except as
// expressly provided in the Agreement, Aware does not grant any express or
// implied rights to you to or under Aware or any third party patents, copyrights,
// trademarks, or trade secret information.  Additionally, you shall reproduce
// and apply any copyright or other proprietary rights notices included on or
// embedded in the software to any copies or derivative works made thereof, in
// whole or in part, in any form.  These rights are provided for information
// clarification, other restrictions of rights may apply as well.
//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//
//
// Filename : $RCSfile: str_basic_type.h $
// Creator  : Leiter Kang
// Created  : 07/31/2007
// Revision : $Revision: 1.2 $
// Rev Date : $Date: 2008/12/11 17:54:13Z $
//
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Description: Basic Data Types for Strymon BM
//
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

#ifndef _BASIC_TYPES
#define _BASIC_TYPES

//-------------------- Basic Types --------------------

//----- variable type definitions -----
typedef char           int8;     // prefix c
typedef short          int16;    // prefix s
typedef int            int32;    // prefix l
#ifndef MSVC_ONLY
typedef long long      int64;
#endif
typedef unsigned char  uint8;    // prefix uc
typedef unsigned short uint16;   // prefix us
typedef unsigned int   uint32;   // prefix ul
typedef unsigned char  FlagT;    // prefix ft
typedef unsigned int   Float32;
typedef double         float64;  // prefix d
#endif //#ifndef _BASIC_TYPES

// accumulator type - prefix a
#ifndef acc
  #ifdef MSVC_ONLY
    // 64 bits
    #define acc __int64
    #define W_ACC_TYPE (64)
  #else
    // 64 bits
    #define acc long long
    #define W_ACC_TYPE (64)
  #endif  //#ifdef MSVC_ONLY
#endif  //#ifndef acc

#ifndef FALSE
#define FALSE           0
#endif
#ifndef TRUE
#define TRUE            1
#endif


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Modification History:
//
//   $Log: str_basic_type.h $
//   Revision 1.2  2008/12/11 17:54:13Z  yangcao
//   Revision 1.2  2007-08-03 16:13:54-04  lkang
//   removed use of UNIX_PLATFORM macro
//
//   Revision 1.1  2007-07-31 15:26:27-04  lkang
//   Initial Revision
//
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
