/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright 1998-2008 (c) Aware, Inc.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//--
//
// The software is owned by Aware, Inc. and is protected by United States
// copyright laws and international treaty provisions. Therefore, you must treat
// the software like any other copyrighted material.  You may not use or copy
// the software or any accompanying written materials for any other purpose than
// what is described in the Development and License Agreement
// entered into with Aware Inc. (the "Agreement").  Except as
// expressly provided in the Agreement, Aware does not grant any express or
// implied rights to you to or under Aware or any third party patents, copyrights,
// trademarks, or trade secret information.  Additionally, you shall reproduce
// and apply any copyright or other proprietary rights notices included on or
// embedded in the software to any copies or derivative works made thereof, in
// whole or in part, in any form.  These rights are provided for information
// clarification, other restrictions of rights may apply as well.
//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//-//
//
// Filename : $RCSfile: cri_private.h $
// Creator  : Aware, Inc.
// Created  : 03/11/2008
// Revision : $Revision: 1.2 $
// Rev Date : $Date: 2008/10/30 18:16:47Z $
//
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Description: Internal prototypes and variable declarations for CRI BM
//
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

//-- exception --
extern int16 gs_CRIException;

// ------ internal prototypes ------
void FFT_Stall_Done(uint8 uc_port);

void CRI_RX_PMS_GO_CHECK_CASCADE (uint8 uc_port);
void CRI_RX_QTP_GO_CHECK_CASCADE (uint8 uc_port);
void CRI_RX_QT_GO_CHECK_CASCADE (uint8 uc_port);
void CRI_RX_FFT_GO_CHECK_CASCADE (uint8 uc_port);

void CRI_TX_PARR_GO_CHECK_CASCADE (uint8 uc_port);
void CRI_TX_IFFT_GO_CHECK_CASCADE (uint8 uc_port);
void CRI_TX_QT_GO_CHECK_CASCADE (uint8 uc_port);
void CRI_TX_QTP_GO_CHECK_CASCADE (uint8 uc_port);
void CRI_TX_PMS_GO_CHECK_CASCADE (uint8 uc_port);

void CRI_Update_AMASK(uint8 uc_port, uint8 zero_or_one, uint8 tx_or_rx);
void CRI_SoftReset(uint32 ul_word);
void CRI_SetPortMode(uint32 ul_word);
void CRI_Update_ATSLOT(uint8 uc_port, uint8 tx_or_rx);

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Modification History:
//
//   $Log: cri_private.h $
//   Revision 1.2  2008/10/30 18:16:47Z  myong
//   changed to remove build errors/warnings
//   Revision 1.1  2008/10/30 15:48:19Z  myong
//   Initial revision
//   Revision 1.1  2008-03-13 14:25:27-04  astone
//   Initial Revision
//
//
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

