/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2000 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/****************************************************************************
;  Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413
;  Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;
;  File Name: signals.h
;
;  Header file for signals from/to Alphaeus.
;
*****************************************************************************/

#ifndef _SIGNALS_H
#define _SIGNALS_H

#include "alp_io_typedef.h"

extern Alphaeus_Input_t t_Alphaeus_Input;
extern Alphaeus_Output_t t_Alphaeus_Output;

#ifdef __cplusplus
extern "C" {
#endif

void AlphaeusSignalReset(void);
void Read_AlphaeusInSigs(Alphaeus_Input_t *pt_Input);
Alphaeus_Input_t* Get_AlphaeusInSigs(void);
void Write_AlphaeusOutSigs(Alphaeus_Output_t *pt_Output);
Alphaeus_Output_t* Get_AlphaeusOutSigs(void);
void Update_AAI_TX_DONE_Signals(void);
void Update_AAI_RX_DONE_Signals(void);
void Set_AAI_TX_DONE(void);
void Set_AAI_RX_DONE(void);

#ifdef __cplusplus
}
#endif

#endif //_SIGNALS_H
