/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2000 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/****************************************************************************
;  Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413
;  Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;
;  File Name: fir.h
;
;  Prototypes of functions for implementing FIR interpolators and
;  decimators.
;
*****************************************************************************/

#ifndef _FIR_H
#define _FIR_H

#include "strymon_cpe_typedef.h"

int16 interp_fir(int16* psa_Input, int16 s_InputLength, int16* psa_Output, InterpFir_t* pt_InterpFir);
int16 decim_fir(int16* psa_Input, int16 s_InputLength, int16* psa_Output, int16* ps_OutputLength, DecimFir_t* pt_DecimFir);
void FirFilter(FDF_FirStruct_t *t_FirStruc, FlagT ft_OutputSample);
acc AccumAdd(acc x, acc y, int16 s_AccWidth);
int16 FDF_AccScaleSaturate(FDF_FirStruct_t *t_FirStruc);

#endif // _FIR_H
