/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2004 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/****************************************************************************
;  Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413
;  Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;
;  File Name: strymon_cpe.h
;
;  Function prototypes for the Strymon CPE behavioral model.
;
*****************************************************************************/

#ifndef _STRYMON_CPE_H
#define _STRYMON_CPE_H

#include "strymon_cpe_typedef.h"

void StrymonCPE_Reset(void);
void STR_InitializeBM(void);

/* Sample clock */
int16 StrymonCPE_8832kHzClock(StrymonCPE_Input_t *pt_Input, StrymonCPE_Output_t *pt_Output);

/* For Software Trigger */
int16 StrymonCPE(StrymonCPE_Input_t *pt_Input, StrymonCPE_Output_t *pt_Output);

/* Clean past samples in the corresponding block - bnum */
void Strymon_ClearPastSamples(int16 bnum);

/* DSP shared-memory interface */
void Set_StrymonCPE_MemBaseAddr(uint32 ul_MemAddr, uint32 ul_RegAddr);
int16 StrymonCPE_ReadWord(uint32 ul_PhysAddr, uint16 *pus_word);
int16 StrymonCPE_WriteWord(uint32 ul_PhysAddr, uint16 us_word);
int16 StrymonCPE_SetWord(uint32 ul_PhysAddr, uint16 us_mask);
int16 StrymonCPE_ResetWord(uint32 ul_PhysAddr, uint16 us_mask);
int16 StrymonCPE_ReadLongWord(uint32 ul_PhysAddr, uint32 *pul_lword);
int16 StrymonCPE_WriteLongWord(uint32 ul_PhysAddr, uint32 ul_lword);
int16 StrymonCPE_SetLongWord(uint32 ul_PhysAddr, uint32 ul_mask);
int16 StrymonCPE_ResetLongWord(uint32 ul_PhysAddr, uint32 ul_mask);

#endif /* _STRYMON_CPE_H */
