/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2000 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/****************************************************************************
;  Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413
;  Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;
;  File Name: io.h
;
;  Prototypes of sample input/output functions for interfacing the
;  Strymon CPE behavioral model. These functions are not part of the
;  behavioral model. They are used by the sample test application
;  test_strymon_cpe.
;
*****************************************************************************/

#ifndef _IO_H
#define _IO_H

#include <stdio.h>
#include "strymon_cpe_typedef.h"

extern FILE *Strymon_Rx_input,
         *Strymon_Rx_output,
         *Strymon_Tx_input,
         *Strymon_Tx_output,
         *Strymon_AEC_output;

int16 Get_RxInput(int16* ps_RxInput);
int16 Get_TxInput(int16* ps_TxInput);
void Put_RxOutput(int16 s_RxOutput);
void Put_TxOutput(int16 s_TxOutput);
void Put_AECOutput(int16 s_AECOutput);

#endif // _IO_H
