/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2004 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
*-------------------------------------------------------------------------------
*
*   Aware DMT Technology. Proprietary and Confidential.
*
*   40 Middlesex Turnpike, Bedford, MA 01730-1413
*   Phone (781) 276 - 4000
*   Fax   (781) 276 - 4001
*
*   filename: bcr_cocomo_interface.h
*
*   This file Specifies the Cocomo to BCR interface.  This interface
*  includes the register read/write functions, core reset functions, BM
*  intialization functions, and any other cocomo/BM only functions/variables
*  that are required to run a HW Engine simulation.  These functions are NOT
*  required by, and unavailable for, actual HW.
*
*-------------------------------------------------------------------------------
*/



#ifndef _BCR_COCOMO_INTERFACE_H
#define _BCR_COCOMO_INTERFACE_H

#ifdef __cplusplus
extern "C" {
#endif

#include "bcr_io_typedef.h"

//=============================================================================
// BCR BM clocking functions
//=============================================================================

   void BCR_Clock();

//=============================================================================
// BCR initialization functions
//=============================================================================
   void BCR_InitializeBM(void);

//=============================================================================
// BCR reset functions
//=============================================================================
   void BCR_Reset(void);

//=============================================================================
// BCR functions for reading/writing RAM blocks and registers
//=============================================================================
   int32 BCR_WriteWord(uint32 addr, uint32 ul_data, uint8 uc_ByteEnable);
   int32 BCR_ReadWord(uint32 addr, uint32 *pul_data, uint8 uc_ByteEnable);

   int32 BCR_GetTxFrameBuffer(uint8 **puc_BaseAddr);

   int32 BCR_GetRxFrameBuffer(uint8 **puc_BaseAddr);

   uint8 BCR_GetVBC0Byte();

   uint8 BCR_GetVBC1Byte();

   uint8 BCR_PutVBC0Byte(uint8 );

   uint8 BCR_PutVBC1Byte(uint8 );

#ifdef __cplusplus
}
#endif

#endif // _BCR_COCOMO_INTERFACE_H
