/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2000 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/****************************************************************************
;  Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413
;  Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;
;  File Name: cri.h
;
;  Main header file for CRI behavioral model.
;
*****************************************************************************/

#ifndef _CRI_H
#define _CRI_H

#include "cri_cocomo_interface.h"
#include "cri_dsp_interface.h"

/* For DLL Export/Import*/
#ifdef _EXPORTING
   #define _DECLSPEC    __declspec(dllexport)
#else
   #define _DECLSPEC
#endif

// Macros
#define RX_SYM_UPDATE_PERIOD  1
#define TX_SYM_UPDATE_PERIOD  1

// Memory Map
extern uint16  us_CRI_Reg_BaseAddr;
// Output Signals
extern CRI_Output_t t_CRI_Output;

#ifdef __cplusplus
extern "C" {
#endif

void CRI_ResetOutputSignals(void);
void CRI_GetOutputSignals(CRI_Output_t *pt_CRI_Output);

#ifdef __cplusplus
}
#endif

#undef _DECLSPEC
#endif //_CRI_H
