/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2004 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
*-------------------------------------------------------------------------------
*
*   Aware DMT Technology. Proprietary and Confidential.
*
*   40 Middlesex Turnpike, Bedford, MA 01730-1413
*   Phone (781) 276 - 4000
*   Fax   (781) 276 - 4001
*
*   filename: zep_ilv_data.h
*
*   This file contains private functions and variables which are visible
*   by the ZEP_ILV BM only.
*
*-------------------------------------------------------------------------------
*/

#ifndef _ZEP_ILV_DATA_H
#define _ZEP_ILV_DATA_H

// Zephyr-ILV TX registers
extern ZEP_ILV_Tx_Registers_t gt_ZEP_ILV_Tx_Registers;

// Zephyr-ILV RX registers
extern ZEP_ILV_Rx_Registers_t gt_ZEP_ILV_Rx_Registers;

// Zephyr-ILV BM internal registers
extern ZEP_ILV_BM_Registers_t gt_ZEP_ILV_BM_Registers;

// buffers represent each memory block
extern uint8 guca_ILVB_Buffer[];
extern uint8 guca_DILVB_Buffer[];
extern uint8 guca_TxDTB_Buffer[];
extern uint8 guca_RxDTB_Buffer[];
extern uint16 gusa_IFB_Buffer[];
extern uint32 gula_IFWP_Buffer[];
extern uint32 gula_IFRP_Buffer[];
extern uint16 gusa_DFB_Buffer[];
extern uint32 gula_DFWP_Buffer[];
extern uint32 gula_DFRP_Buffer[];

#endif // _ZEP_ILV_DATA_H
