/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2000 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
 *------------------------------------------------------------------------
 *
 *   Aware DMT Technology. Proprietary and Confidential.
 *
 *   40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
 *   Phone (781) 276 - 4000
 *   Fax   (781) 276 - 4001
 *
 *   RQuietFR2TxF.c
 *
 *   Fast Retrain TX State Functions for ATU-R.
 *   Covering the TX states: R_QUIET_FR2
 *
 *   Notes:
 *
 *   R_ECT_FR is implemented in xcvr_tx2.c
 *
 *
 *------------------------------------------------------------------------
 */
#include "common.h"
#include "rt_tones.h"
#include "tx_ops.h"
#include "gdata.h"
#include "crc16.h"
#include "xrtstate.h"
#include "fifo.h"
#include "DSLEngin.h"
#include "profile2.h"
#include <string.h>
#include "TxTneSt.h"
#include "TxMTnSt.h"
#include "states.h"
#include "RReverbFrTxF.h"

/*^^^
*-------------------------------------------------------------------
########               ########
######## TX ROUTINES   ########
########               ########
*-------------------------------------------------------------------
*^^^
*/




/*^^^
 *------------------------------------------------------------------------
 *
 *  Name: RQuietFR2TxF
 *
 *  Description: The Transmitter remains quiet for 1536 symbols
 *  in R_QUIET_FR2_TX state.
 *
 *  Prototype: void RQuietFR2TxF(void)
 *
 *  Input Arguments: none
 *
 *  Output Arguments: none
 *
 *  Return: none
 *
 *  Global Variables Used:
 *
 *  Notes: implements R_QUIET_FR2_TX only.
 *
 *------------------------------------------------------------------------
 *^^^
 */
void RQuietFR2TxF(void) {

   if (gl_TxSymbolCount == 0) {

      /* Produce quiet signal */
      gft_IFFT_On=TRUE;
      TxToneSetUp(0,0,0);
   }

   if (gl_TxSymbolCount == R_QUIET_FR2_TX_LEN-1) {
      gs_TxNextState = R_REVERB_FR4_TX;
      gpF_TxStateFunc = (PtrToFunc)RReverbFrTxF;
   }
}
