/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2009 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/****************************************************************************
;  Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413
;  Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;
;  File Name: STR_mask.c
;
;  Strymon CPE core interface layer.
;
*****************************************************************************/

#include "common.h"
#include "gdata.h"
#include "tdq_init.h"
#include "config.h"
#include "memrymap.h"
#include "LL_IOf.h"
#include "STR_IOf.h"
#include "STR_InitFilter.h"
#include "STR_Filt.h"
#include "dec_adap.h"
#include "ec_data.h"
#include "cmv.h"


/***************************************************************************************
;  Subroutine Name: MaskRxInput
;
;  Description:
;     This function zeroes the Rx signal at the output of the iir/decimator block
;
;  Prototype:
;     void MaskRxInput(void)
;
;  Input Arguments:
;     none
;  Output Arguments:
;     none
;  Return Value:
;     none
;
;**********************************************************************************************/
C_SCOPE void MaskRxInput(void)
{

    // Zeros the current rx iir output
    SetCoreReg((uint32)V_DECIM_CFG_ADDR, MASK_BIT31);

}

/***************************************************************************************
;  Subroutine Name: UnmaskRxInput
;
;  Description:
;     This function restores the Rx signal at the output of the iir/decimator block
;
;  Prototype:
;     void UnmaskRxInput(void)
;
;  Input Arguments:
;     none
;  Output Arguments:
;     none
;  Return Value:
;     none
;
;**********************************************************************************************/
C_SCOPE void UnmaskRxInput(void)
{
    //unmask iir output
    ResetCoreReg((uint32)V_DECIM_CFG_ADDR, MASK_BIT31);

}

