/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C) 1998-2000 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
 *----------------------------------------------------------------------------
 *
 *   Aware DMT Technology. Proprietary and Condfidential
 *
 *   40 Middlesex Turnpike, Bedford, MA 01730-1413
 *   Phone (781) 276-4000
 *   FAX   (781) 276-4001
 *
 *   alp_enableaai_txrx.c
 *
 *   Alphaeus interface functions.
 *
 *
 *----------------------------------------------------------------------------
 */

#include "common.h"
#include "gdata.h"
#include "LL_IOf.h"
#include "memrymap.h"

/***************************************************************************************
;  Subroutine Name: EnableAAI_Tx
;
;  Description:
;     This function enables the Tx path of the Alphaeus core.
;
;  Prototype:
;     void EnableAAI_Tx(void)
;
;  Input Arguments:
;     none
;
;  Output Arguments:
;     none
;
;  Return Value:
;     none
;
;  Global Variables:
;
;   Substates:
;
;**********************************************************************************************/
C_SCOPE void EnableAAI_Tx(int16 s_bc)
{
// BC enable bit is not defined in Hercules
// bearer channel mapping is done in ConfigBcrTxPath()
}

/***************************************************************************************
;  Subroutine Name: EnableAAI_Rx
;
;  Description:
;     This function enables the Rx path of the Alphaeus core.
;
;  Prototype:
;     void EnableAAI_Rx(int16 s_bc)
;
;  Input Arguments:
;     none
;
;  Output Arguments:
;     none
;
;  Return Value:
;     none
;
;  Global Variables:
;
;   Substates:
;
;**********************************************************************************************/
C_SCOPE void EnableAAI_Rx(int16 s_bc)
{
// BC enable bit is not defined in Hercules
// bearer channel mapping is done in ConfigBcrTxPath()
}


