/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C) 1998-2000 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
 *----------------------------------------------------------------------------
 *
 *   Aware DMT Technology. Proprietary and Condfidential
 *
 *   40 Middlesex Turnpike, Bedford, MA 01730-1413
 *   Phone (781) 276-4000
 *   FAX   (781) 276-4001
 *
 *   cri_ini.c
 *
 *   init Electra block core interface function
 *
 *
 *----------------------------------------------------------------------------
 */

#include "memrymap.h"
#include "LL_IOf.h"
#include "gdata.h"

void InitElectra(void)
{
#ifndef HERCULES_ADSL_CPE
// uint16 us_data;

   if (guc_Iridia_Revision_Number >= IRIDIA_31)
   {
      // set electra register E_NTRSTEP, which corresponds to
      // address 0x30F07 to the value = 0x0400
      WriteCoreReg(0x43c7,(uint16)0x0400);

      // set electra register E_NTRCNT, which corresponds to
      // address 0x30F04 to the value = 0x1590. To compute the
      // 1st argument, 0x43c1 = (0x30F04-0x20000)/4
      WriteCoreReg(0x43c1,(uint16)0x1590);
   }
#endif // HERCULES_ADSL_CPE
}
