/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2005 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/****************************************************************************
;  Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413
;  Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;
;  File Name: IRI_IOf.h
;
;  Header file for Iridia CPE core interface layer.
;
*****************************************************************************/

#ifndef _IRI_IOF_H
#define _IRI_IOF_H
#if 0
#define  IRI_SAMPLEREG_IR_SOURCE    0
#define  IRI_SAMPLEREG_IR_MODE      1
#define  IRI_SAMPLEREG_IR_ALIGN     2
#define  IRI_SAMPLEREG_IT_SOURCE    3
#define  IRI_SAMPLEREG_IT_MODE      4
#define  IRI_SAMPLEREG_IT_LENGTH    5
#define  IRI_SAMPLEREG_IT_PREFIX    6
#define  IRI_SAMPLEREG_IT_FSOFFSET  7
#endif

//#ifdef ADSL_62
#define IFFT_DSP_REORD_ENA    (1)
#define IFFT_DSP_REORD_DIS    (0)
#define IFFT_BUF_READ   (0)
#define IFFT_BUF_WRITE  (1)
#define TX_QT_BUF (0)
#define TX_FT_BUF (1)
#define TX_FDF_BUF   (2)

#define FFT_DSP_REORD_ENA     (1)
#define FFT_DSP_REORD_DIS     (0)
#define FFT_BUF_READ (0)
#define FFT_BUF_WRITE   (1)
#define RX_QT_BUF (0)
#define RX_FT_BUF (1)
#define RX_FDF_BUF   (2)


//#endif //ADSL_62
/*
void InitIridia();
void ReadCoreRegSampled(uint16  us_SampledRegisterNumber , uint16 *pus_word);
void WriteCoreRegSampled(uint16 us_SampledRegisterNumber, uint16 us_word);
void SetCoreRegSampled(uint16 us_SampledRegisterNumber, uint16 us_mask);
void ResetCoreRegSampled(uint16 us_SampledRegisterNumber, uint16 us_mask);
*/



uint16 WhichPhysicalBuffer(uint16 s_logicalBuffer);
void ConfigRTVBuf0_train(void);
void ConfigRTVBuf0_train_Accum(void);
void ConfigRTVBuf0_RCD_OUT(void);
void ConfigRTVBuf1_SFDQ_OUT(void);
uint32 GetPingPongTableAddress(int16 s_table_id, int16 s_set_id);
void DisableTxBufferSwap(void);
#ifdef HW_VECPOW_ACCUM
void TriggerVectorPower(void);
void ReadVectorPower(void);
#endif

void RestoreRtvCaptureModeSetting(void);
void SaveRtvCaptureModeSetting(void);
#ifdef ISI_ANALYSIS_ON
void WhichCPBuffers(uint16 *, uint16 *);
#endif

//adsl 62
void CopyTxTable_InactiveToActive(int16 s_mintone, int16 s_maxtone);
void CopyRxTable_InactiveToActive(int16 s_mintone, int16 s_maxtone);

void WhichFFTBuffers(uint32 *pul_FFTInputBuffer, uint32 *pul_FFTOutputBuffer);
void WhichFFTBuffers2(uint32 *pul_FFTInputBuffer, uint32 *pul_FFTOutputBuffer);
void WhichIFFTBuffers(uint32 *pul_IFFTInputBuffer, uint32 *pul_IFFTOutputBuffer);


void ReadFftBuffer(int16 *psa_data, int16 s_offset, int16 s_NumTones, FlagT ft_timedomain);

void AccessFftBuffer(int16 *psa_buf, int16 s_offset, int16 s_NumTones,
               FlagT gft_DigitRev, FlagT gft_ReadWrite, FlagT gft_WhichBuf);
void GetFftBufAddr(uint32 *pul_addr, FlagT gft_WhichBuf);
void ReadIfftBufStatus(uint32 *pul_data);

void AccessIfftBuffer(int16 *psa_buf, int16 s_offset, int16 s_NumTones,
               FlagT gft_DigitRev, FlagT gft_ReadWrite, FlagT gft_WhichBuf);
void GetIfftBufAddr(uint32 *pul_addr, FlagT gft_WhichBuf);

#endif /*_IRI_IOF_H */
