/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2000 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/****************************************************************************
;  Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413
;  Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;
;  File Name: misc.c
;
;  Additional HW Engine functions
;
*****************************************************************************/
#include "typedef.h"
//#include "DSLEngin.h"
#include "LL_IOf.h"
//#include "iridia.h"
#include "IRI_IOf.h"
#include "STR_IOf.h"
#include "STR_Ini.h"
#include "ZPH_IOf.h"
#include "ALP_IOf.h"
//#include "rt_state.h"
#include "afe.h"
#include "memrymap.h"
#include "dec_adap.h"
#include "cmv.h"
#include "fifo.h"
#include "gdata.h"



#ifndef TARGET_HW

/******************************************************
* Global variables defined in common DSL Engine API
*******************************************************/

/* Fast retrain */
int16 gs_FRCyclicPrefixInsertCnt = R_C_SEGUE_FR2_RX_LEN-2;

/******************************************************
* API Functions defined in common DSL Engine API
*******************************************************/
void TxFilterPutTxSymbol(void) {};

void RShowtimeRx_SWE(void) {};
void RShowtimeTx_SWE(void) {};
#endif

/*^^^
 *------------------------------------------------------------------------
 *
 *  Name : InitModemEngine_PostHandshake
 *
 *  Prototype:  void InitModemEngine_PostHandshake(void)
 *
 *    Initializes variables in Modem engine
 *
 *  Input Arguments:
 *
 *  Output Arguments:
 *
 * Return:
 *      None
 *
 *  Global Variables Used:
 *
 *  Notes:
 *
 *------------------------------------------------------------------------
 *^^^
 */

void InitModemEngine_PostHandshake(void)
{
   // Here we do whatever setup of the Engine layer is
   // required prior to starting the training (or fast
   // retrain) phase.

#ifndef ISDN
    /* If G.Lite, updates TDQ rate to run at 1.1MHz */
   if ((STATArray[STAT_Mode] & STAT_ConfigMode_G992_2_AB) || (STATArray[STAT_Mode] & STAT_ConfigMode_G992_2_C))
   {
#ifndef ADSL_62
      AddFunctionToFifo(gp_RxLoadingFunctionFifo,Reconfig_STR_SMODE);
#else
     /* ==================================================================================== */
   /* update Strymons sample rate (input rate of each block) due to fft/ifft length change */
   /* =====================================================================================*/
        AddFunctionToFifo(gp_RxLoadingFunctionFifo, Reconfig_DFE_SampleRate);
#endif
      AddFunctionToFifo(gp_RxLoadingFunctionFifo,Reconfig_DFE_Rx);
   }
#endif //ISDN

}


