/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2005 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
*-------------------------------------------------------------------------------
*
*   Aware DMT Technology. Proprietary and Confidential.
*
*   40 Middlesex Turnpike, Bedford, MA 01730-1413
*   Phone (781) 276 - 4000
*   Fax   (781) 276 - 4001
*
*   filename: modem_hw.h
*
*   Header file for modem_hw.c.
*
*-------------------------------------------------------------------------------
*/

#ifndef _MODEM_HW_H
#define _MODEM_HW_H

// variables defined in modem_hw.c
extern int16 gsa_TmpTxOutBuf[];
extern int16 gs_TmpTxOutBufIndex;

extern int16 gsa_TxDtoABuf[]; // output from TX filter (D/A input)
extern int16 gsa_RxAtoDBuf[]; // input ADC buffer
extern int16 gs_AtoD_PutPtr; // ADC buffer put pointer
extern int16 gs_AtoD_GetPtr; // ADC buffer get pointer

extern int32 gl_TxFrameCnt;
extern int32 gl_RxFrameCnt;
extern int16 gs_FirstTimeCounter;

extern int16 gs_AecDacSample;
extern int16 gs_AecDacSampleValid;

extern int16 gs_bypass_strymon;
extern int16 gs_IridiaUpClockPeriod;
extern int16 gs_Up_Sample_Clock;
extern int16 gs_Dn_Sample_Clock;
extern int16 gs_Strymon_Clock;
extern int16 gs_TxSampleIndex;
extern int16 gs_RxSampleIndex;
extern int16 gs_ZeroSample;
extern int16 gs_upIndex;
extern int16 gs_sampleCnt;
extern int16 gs_skipSampleCnt;
extern uint32 gl_TotalRxSampleCount;

// functions defined in modem_hw.c
void OutputIridiaTxSample(void);
void InputIridiaRxSample(void);
void DownSampler(int16 *psa_inbuf, int16 *psa_outbuf, int16 s_length, int16 s_factor);
void Pause(int16 s_Marker);
int16 InitModem_PreHandshake(void);

#endif // _MODEM_HW_H
