/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 2001 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/****************************************************************************
;  Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
;  Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;  File Name: memsetbf.c
;
;  Functions for setting the values of a buffer.
;
;***************************************************************************/

#include <string.h>
#include "typedef.h"

/*^^^
 *------------------------------------------------------------------------
 *
 *  Name : MemSetBuffer
 *
 *  Description:  Similar to standard memset(), but specifies the destination address
 *             using origin+offset.
 *  Prototype:
 *    void MemSetBuffer(int16 *psa_dstptr, int16 s_dst_offset, uint8 uc_value, int16 s_Nbytes)
 *
 *  Input Arguments:
 *    int16 *psa_dstptr - Pointer to origin of destination buffer.
 *    int16 s_dst_offset - Added to psa_dstptr to get starting destination address.
 *      uint8 uc_value - Value to write to buffer.
 *    int16 s_Nbytes - Number of bytes to write.
 *
 *
 *  Output Arguments:
 *    None.
 *  Return:
 *    None.
 *
 *  Notes:
 *    1) Whenever possible, psa_dstptr and psa_srcptr should be pointers to globally-declared arrays.
 *------------------------------------------------------------------------
 *^^^
 */

void MemSetBuffer(int16 *psa_dstptr, int16 s_dst_offset, uint8 uc_value, int16 s_Nbytes)
{
   memset(psa_dstptr + s_dst_offset, uc_value, s_Nbytes);
}

