/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2004 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/**********************************************************************
 *
 * Aware DMT Technology. Proprietary and Confidential.
 *
 * ADDRESS:          40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
 * TELEPHONE:        781.276.4000
 * FAX:              781.276.4001
 * WEB:              http://www.aware.com
 *
 * FILE:             HybridTraining.h
 * DESCRIPTION:      Header file for HybridTraining.c
 *
 **********************************************************************/

#ifndef _HYBRIDTRAINING_H
#define _HYBRIDTRAINING_H

#include "typedef.h"

/**********************************************************************
 * Functions prototypes
 **********************************************************************/
   extern FlagT HybridTrainingPipeline_VR9(int16 s_TrainingType);
   extern void  InitHybridVars_VR9(void);
   extern void InitHybridAccum(int16 s_TrainingType);
   extern BkgdFunction BgHybCalcSignalPSD;
   extern BkgdFunction BgHybCalcAndCompMetric;
   extern int16 GetTotalBits(void);
   extern void AdjustRevRefPwr(void);

/**********************************************************************
 * Definitions
 **********************************************************************/
#define STRAIGHTLOOP_HYBIDX  (0)

#ifndef VR9_HYB_TRAIN_DEBUG
   //   #define VR9_HYB_TRAIN_DEBUG
#endif //#ifndef VR9_HYB_TRAIN_DEBUG

#endif /* _HYBRIDTRAINING_H */

