/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-1999 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _ACT_T1413_H
#define _ACT_T1413_H

/**********************************************************************
 *
 * Aware DMT Technology. Proprietary and Confidential.
 *
 * ADDRESS:          40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
 * TELEPHONE:        781.276.4000
 * FAX:              781.276.4001
 * WEB:              http://www.aware.com
 *
 * FILE:             act_t1413.h
 * DESCRIPTION:      Header file containing functions that implement
 *                   T1.413 issue 2 activation states.
 *
 **********************************************************************/
#include "T1413.h"

/**********************************************************************
 * FUNCTIONS
 **********************************************************************/

//XDSLRTFW-326 Feature_ALL_Try_GHS_Before_T1413_ALL (Start)
#define MAX_ALLOWED_GHS_FAILS         (3)
//XDSLRTFW-326 Feature_ALL_Try_GHS_Before_T1413_ALL (End)
extern void RCReveilleRxF(void);
extern void RCActRxF(void);
extern void RAckTxF(void);
extern void RActReqTxF(void);
extern void RQuiet1TxF(void);

#endif /* _ACT_T1413_H */

