/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 2001 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _DEC_ADAP_DATA_H
#define _DEC_ADAP_DATA_H
/****************************************************************************
;  Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
;  Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;  dec_adap_Data.h
;
;  Header file for dec_adap_Data.c
;
;***************************************************************************/
// ******************************************************************
// dec_adap_Data.h
//
// History
//
// 15/09/2011 Kannan: DEC coefficient download state variable.
//                    declaration
//      Grep for XDSLRTFW-251 PERF_DS_PlusBisDmt_ALL_DECTraining
// ******************************************************************
#include "typedef.h"

extern uint8 guc_DECAdaptationState;
extern uint8 guc_DECTxCaptureFlag;
extern uint8 guc_DECRxCaptureFlag;
extern uint8 guc_DECCoefUpdateFlag;
extern uint8 guc_DECCoefDnloadFlag;
extern uint8 guc_DECCoefDnloadState; //XDSLRTFW-251 PERF_DS_PlusBisDmt_ALL_DECTraining (START - END)
extern uint8 guc_CalcDECCaptureOffsetFlag;
extern FlagT gft_SynchSymbolChange;
extern FlagT gft_CorruptedSynchFrame;
extern int16 gs_DECAdaptationTxOffset;
extern int16 gs_DECAdaptationRxOffset;
extern int16 gs_RxTxFrameAlign;
extern int16 gs_DECAdaptationCnt;
extern int16 gs_TxFrameLength;
extern int16 gs_Log2DECUpsamplingFactor;
extern int16 gs_DECLengthPerPhase;
extern int16 gs_DECTxDataCaptureStartCnt;
extern int16 gs_DECTxDataCaptureFrameCnt;
extern int16 gs_DECTxDataCaptureLength;
extern int16 gs_DECAdaptExp;
extern int16 gsa_DECAdaptationRxData[];
extern int16 gsa_DECAdaptationAvgRxData[];
extern int16 *gpsa_DECAdaptationTxData;
extern uint16 *gpusa_pre_dec_h_lsw;
extern int32 gl_numCorruptedSynchFrames;
extern int32 *gpla_DECAdaptationRxDataAccum;
extern int16 gs_DECAdaptationInputCaptureOffset;

#endif //_DEC_ADAP_DATA_H
