/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2003 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _DECIMALGAIN_H
#define _DECIMALGAIN_H

/**********************************************************************
 *
 * Aware DMT Technology. Proprietary and Confidential.
 *
 * ADDRESS:          40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
 * TELEPHONE:        781.276.4000
 * FAX:              781.276.4001
 * WEB:              http://www.aware.com
 *
 * FILE:             decimalgain.h
 * DESCRIPTION:      Header file for decimalgain.c.
 *
 **********************************************************************/

#include "typedef.h"
//XDSLRTFW-1727
 #define     FG_PLUS_2_5_dB  (10925)
 #define     FG_MINUS_2_5_dB  (6143)
 #define     FG_MINUS_8_3_dB  (3143)
 #define     FG_MINUS_7_dB  (3659)
 #define    FG_MINUS_13_dB  (1775)  //-13.28dB
 #define    FG_MINUS_14_5_dB (1543)
 #define    FG_MINUS_10_dB   (2590)

 #define    FG_MIN_VALUE      (FG_MINUS_10_dB) //-10dB linear in q13 format
/**********************************************************************
 * VARIABLES
 **********************************************************************/

/**********************************************************************
 * FUNCTIONS
 **********************************************************************/
int16 DecimalGain(int16 s_gain_db);

#endif /* _DECIMALGAIN_H */


