/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-1999 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _HS_MESG_H
#define _HS_MESG_H

/**********************************************************************
 *
 * Aware DMT Technology. Proprietary and Confidential.
 *
 * ADDRESS:          40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
 * TELEPHONE:        781.276.4000
 * FAX:              781.276.4001
 * WEB:              http://www.aware.com
 *
 * FILE:             hs_mesg.h
 * DESCRIPTION:      Header file for message handling functions used
 *                   during Handshake.
 *
 **********************************************************************/

#include "typedef.h"
#include "ghs.h"

/**********************************************************************
 * FUNCTIONS
 **********************************************************************/
extern int16 FormMessage(InfoField_t *t_Info, uint8 uca_Msg[]);
extern void DecodeMessage(void);
extern void CopyInfoField(InfoField_t *t_Source, InfoField_t *t_Target, int16 s_CopyNS);
//XDSLRTFW-1502 (start_end)
int16 FormTpsTCParameters(TPS_TC_Type_t *pt_TpsTcType, uint8 *puc_M, int16 idx, uint16 type, int16 s_isDS);
int16 AddTpsTcInfo(int16 s_bc, Adsl2AllInfo_t *pt_BisInfo, uint8 *puc_M, int16 idx);

#endif /* _HS_MESG_H */

