/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-1999 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _HS_MISC_H
#define _HS_MISC_H

/**********************************************************************
 *
 * Aware DMT Technology. Proprietary and Confidential.
 *
 * ADDRESS:          40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
 * TELEPHONE:        781.276.4000
 * FAX:              781.276.4001
 * WEB:              http://www.aware.com
 *
 * FILE:             hs_misc.h
 * DESCRIPTION:      Header file for miscellaneous functions used
 *                   during handshaking.
 *
 **********************************************************************/

#include "typedef.h"
#include "ghs.h"

/**********************************************************************
 * FUNCTIONS
 **********************************************************************/
extern uint16 CalcCRC_Byte(uint8 uc_Octet, uint16 us_CRC, uint16 us_GenPoly);
extern Complex_t MovingAvg(Complex_t ta_Buf[], int16 s_BufLen, int16 s_Idx, int16 s_WindowLen);
extern void InitializeHSC(HandShakeControl_t *pt_hsc);

extern void TerminateHandshakeTx(void);
extern void TerminateHandshakeRx(void);
extern void SetSelectedModeAnnex(int32 l_SelectedMode);



#endif /* _HS_MISC_H */

