/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-1999 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _STATES_H
#define _STATES_H

/**********************************************************************
 *
 * Aware DMT Technology. Proprietary and Confidential.
 *
 * ADDRESS:          40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
 * TELEPHONE:        781.276.4000
 * FAX:              781.276.4001
 * WEB:              http://www.aware.com
 *
 * FILE:             states.h
 * DESCRIPTION:      Header file for functions that implement the state
 *                   machine.
 *
 **********************************************************************/

/**********************************************************************
 * VARIABLES
 **********************************************************************/

extern int16 SizeTcb;

extern PtrToFunc gpF_TxStateFunc;      //Global function pointer to TX state function
extern PtrToFunc gpF_RxStateFunc;      //Global function pointer to RX state function
extern PtrToFunc gpF_TxStateJumpTo;    //Global function pointer to TX jump state
extern PtrToFunc gpF_RxStateJumpTo;    //Global function pointer to RX jump state


/**********************************************************************
 * FUNCTIONS
 **********************************************************************/
#ifdef TARGET_HW
extern void SetGPIODirectionBits(int16 s_data);
extern void SetGPIOBits(int16 s_data);
extern void ClearGPIOBits(int16 s_data);
extern int16 GetGPIOBit (int16 Pin_Num);
extern void FlashGPIO(void);
#endif
extern void TxForeGround(void);
extern void TxProcessTones(void);
extern void RxForeGround(void);
extern void RxProcessTones(void);
extern void RxProcessTime(void);
extern void EmptyState(void);
extern void ExceptionHandler(void);
extern void RShowtimeTxTC_C(void);
extern FlagT isShowtime(void);


extern void Pause(int16 s_Marker);  //For debug.

#endif /* _STATES_H */


