/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2006 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _TYPEDEF_BASE_H
#define _TYPEDEF_BASE_H

/****************************************************************************
;  Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413
;  Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;
;  File Name: typedef_base.h
;
;  This file contains type definitions used by different files.
;
*****************************************************************************/
//****************************************************************************
//typedef_base.h
//
// History
//
// 25/04/2012 Kannan:
//          1. ADSL DS ReTx feature implementation
//             Grep for "XDSLRTFW-443 Feature_DS_BisPlus_All_ReTx"
//*****************************************************************************************

#ifndef _BASIC_TYPES
#define _BASIC_TYPES

typedef void  (*PtrToFunc)(void);

/* Variable type definitions */
typedef double float64;          /* prefix d in hungarian notation */
typedef short int16;          /* prefix s  */
typedef long  int32;          /* prefix l */
typedef char  int8;              /* prefix c */
typedef unsigned char uint8;     /* prefix uc */
typedef unsigned long uint32;    /* prefix ul */
typedef unsigned short uint16;      /* prefix us */
typedef unsigned long Float32;      /* prefix f */
typedef unsigned char FlagT;     /* prefix ft */
typedef unsigned short   bool;      /* prefix b */
typedef unsigned long long   uint64; // prefix ull //XDSLRTFW-443 Feature_DS_BisPlus_All_ReTx  (START_END)

//VRX518 AFE

// 8-bit signed type.
typedef signed char int8_t;
//     8-bit unsigned type. */
typedef unsigned char uint8_t;

// 16-bit signed type. */
typedef signed short int16_t;
//     16-bit unsigned type. */
typedef unsigned short uint16_t;

//    32-bit signed type. */
typedef signed long int int32_t;
//    32-bit unsigned type. */
typedef unsigned long int uint32_t;

//    64-bit signed type.
typedef signed long long int int64_t;
//   64-bit unsigned type.
typedef unsigned long long int uint64_t;


#endif _BASIC_TYPES


#endif /* _TYPEDEF_BASE_H */

