/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2001 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
 *------------------------------------------------------------------------
 *
 *   Aware DMT Technology. Proprietary and Confidential.
 *
 *   40 Middlesex Turnpike, Bedford, MA 01730-1413
 *   Phone (781) 276 - 4000
 *   Fax   (781) 276 - 4001
 *
 *   version.c
 *
 *   Header file for variables containing version string.
 *
 *------------------------------------------------------------------------
 */
#include <typedef.h>

//XDSLRTFW-3364 (Start)
//Version number format:
//Refer to 'ACK_VersionInfoGet' in Message Catalog ver 2.9 or above

#define VRX518_PLATFORM_ID       (8)
#define VRX318_PLATFORM_ID       (7)
#define VR9_PLATFORM_ID          (5)

#define VERSION_PLATFORM         (VRX518_PLATFORM_ID)   //Platform Number; 8-bits width

#define VERSION_FEATURE          (12)  //Feature Set Number; 8-bits width

#define VERSION_MAJOR            (1)   //Major Version Number; 4-bits width; First version = 0, Last version = 15

#define VERSION_MINOR            (12)   //Minor Version Number; 4-bits width; First version = 0; Last version = 15

#define VERSION_REL_STATUS       (1)   // 0: Release Version i.e. Released after IQ/FW testing to external customers
                                       // 1: Pre-Release Version i.e. IQ/FW testing going on
                                       // 2: Reserved
                                       // 3: Development version i.e. Test firmware release.

#ifdef ISDN
#define VERSION_APP_NUM          (2)   // 1= Annex A, 2 = Annex B
#else
#define VERSION_APP_NUM          (1)   // 1= Annex A, 2 = Annex B
#endif


// If the RELEASE_STATE == 3, then you need to define the following test firmware version
// which will be sent along with the EOC/Overhead Messages
#define VERSION_TEST_FW_SOURCE   (0)   // !! DO NOT USE THIS FIELD !! Reserved for future use

#define VERSION_TEST_FW_NUM      (0x01)   //Test FW release Nos. must start from 1 and up to a maximum of 255 (1,2,3,4 ..9,A,B,C,D,E,F,10,11...,FF)


#define VER_ROM_PRODUCT          1
#define VER_ROM_FEATURE          1
#define VER_ROM_MAINTENANCE      2
#define VER_ROM_DEBUG            4


extern uint16 gusa_FW_version_number[];
//XDSLRTFW-3364 (End)
