/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2003 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/**********************************************************************
 *
 * Aware DMT Technology. Proprietary and Confidential.
 *
 * ADDRESS:          40 Middlesex Turnpike, Bedford, MA 01730-1432 USA
 * TELEPHONE:        (781) 276-4000
 * FAX:              (781) 276-4001
 * WEB:              http://www.aware.com
 *
 * FILE:             RCQuiet1RxF_BIS.c
 * DESCRIPTION:      RX State Function for ATU-R in the C-QUIET1
 *                   states of the Channel Discovery
 *                   Phase in G.dmt.bis.
 *
 **********************************************************************/

#include "common.h"
#include "rt_state.h"
#include "gdata.h"
#include "codeswap.h"

#ifdef BIS_CODESWAP
#include "soc_codeswap.h"
#endif

#include "RCQuiet2RxF.h"
#include "states.h"

/*^^^
 *---------------------------------------------------------------------
 * Function: RCQuiet2RxF_CW
 *
 * Description: Dummy version for codeswap purpose between GHS and
 * XCVR transition
 *
 *---------------------------------------------------------------------
 *^^^
 */

void RCQuiet2RxF_CW(void)
{
#ifdef BIS_CODESWAP
   // Transit to real RCQuiet2RxF once codeswap page XCVR0 has finished
   if((gs_CodeSwapStatus == CODESWAP_IDLE) && (gs_CodeSwapSection==CSPAGE_BIS_DMT_RAM))
   {
         gpF_RxStateFunc = (PtrToFunc)RCQuiet2RxF;
         gft_Quiet_Transit = TRUE;
   }
#endif
}
