/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2009 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*****************************************************************************
;
;   Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413
;   Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;   ec_sequence.c
;
;  Echo Canceller (EC) training/correlation sequece for ADSL_62
;
;
;****************************************************************************/
#include "common.h"
#include "dsp_op.h"
#include "gdata.h"
#include "DSLEngin.h"
#include "compiler.h"
#include "norm_acc48.h"
#include "ec_data.h"
#include "const.h"
#include "ec_init.h"
#include "cmv.h"
#include "data_alloc.h"
#include "ifft_cutback.h"

#ifndef ADSL_62



DATA_BULKO1_BEGIN
int16 gs_CorrelateShift32 = 1; /* Correlates to 0.5 */
int16 gs_CorrelateShift_AnnexA = 1; /* Correlates to 0.5 */
int16 gs_CorrelateShift_AnnexB = 1; /* Correlates to 0.5 */
int16 gs_CorrelateShift_AnnexL_Mask1 = 1; /* Correlates to 0.5 */
int16 gs_CorrelateShift_AnnexL_Mask2 = 1; /* Correlates to 0.5 */



int16 gsa_EC_Train_Seq[EC_TRAIN_SEQ_BUF_SIZE] = {
//int16  usa_sym_taper_tail[TAIL_TAPER_LEN]  = {
                                                1, 3, 7, 12, 19, 27, 36, 47, 58, 72, 86, 101,
                                    117, 134, 151, 169, 188, 207, 227, 246, 266,
                                    285, 305, 324, 343, 361, 378, 395, 411, 426,
                                    440, 454, 465, 476, 485, 493, 500, 505, 509,
                                    511,
//};

//int16 gsa_DECTrainBuf32[64] = {
                            3843, 3161, -3928, 1938, 1557, -2504, -2999, 1075, 816, 70,
                     5446, 1093, -8447, 2367, 2629, 1145, 436, -3677, 578, -1380,
                     5593, -4239, 6019, -1041, -1148, -2499, -1311, 2995, 988, -5457,
                     1370, 4018, 2447, -198, -1301, -574, -2270, -4473, 508, 5593,
                     -4495, 3952, 776, -2516, 2082, -1928, -1275, -3039, -954, 2311,
                     4803, -345, 925, 830, -496, -2263, -4540, 5334, 938, 3325,
                     -3959, -3173, 309, -955,
//};

//int16 gsa_DECCorrBuf32[64] = {
                            8766, 8030, 6850, 8553, 9918, 2540, 2855, 1479, 3020, -144,
                     7474, 3451, 1369, 8732, 13187, 10180, 12060, 5215, 9182, 3043,
                     8937, -2256, 7260, -460, 2819, 162, 4639, 5689, 6869, -1195,
                     5146, 2687, 2316, -4087, -3766, -7063, -6430, -11240, -5376, -4760,
                     -9934, -6870, -6733, -11521, -4491, -8174, -2196, -2559, 5606, 9172,
                     16808, 12328, 16300, 12285, 11234, 3513, 347, 1023, -2459, -4917,
                     -7518, -8053, -163, -518,
//};



/* Datapath Afe and Cocomo */

// Spectrum in AnnexA US band.
//int16 gsa_DECTrainBuf_AnnexA[128] = {
                              -2055, 5113, 7859, -5538, -2107, -3778,  8959, -7002,
                     2388,  1078,   876,  1549, -2084, -8115,  6766, -1197,
                     -10469,   181, -1875,  4609,  3128,  -370,  1764,  5127,
                     -9366,  3907,  5081,  2372,  1195,  6548,  5338, -5508,
                     -4643, -3890,-11542,  1178,  2934, -7352,  2402,  2633,
                        6917,  6031, -6185, -3765,  5079, -6403, -6043,  8046,
                        6178,  -542,  3947, -1345,  6739, -7939, -6241,  5935,
                        -5933,   361,  -916, -6101, -3403,   251,  5040,  6820,
                        -669,  3963,  4147, -4559,  8967,  -419, -6640, -8109,
                        -1235,  8419, -8732,  3761,  3475, -5524,  5254, -4188,
                        -10443,-15938, 10182, 16260,  9692,  1139, -9566, -5190,
                        9602,  4125,-15663,  5181,  1953, -8354, -2151, -1282,
                        8665,  2826,   858,  3286,  8003,  6210, -1734, -4538,
                        -14665,  2320, -3016,  2043, 11418, -3562, -3775, -6555,
                        8072, -1670,  9966,  7628, -1777,  1088, -3879, -4425,
                        7084,-10933, -5574,  6091, -9186,  3317, -6068, 13485,
//};

//int16 gsa_DECCorrBuf_AnnexA[128] = {
                              1328,   358,  1739, -1041,   271, -1254,   705, -1753,
                     -349, -1001,  -779,  -672, -1140, -1016,  -251,   309,
                     -1576,  1205,  -522,  2325,   177,  2429,   195,  3220,
                     -817,  3105,   319,  2666,  -316,  2499,  -281,   715,
                     -1483,   118, -2289,  -109,  -987, -1422,  -828,  -887,
                     -22,  -757,  -659, -1654,   968, -1795,   565,  -345,
                     2167,  -973,  2309,  -940,  2716, -1487,  1517,  -241,
                     1363,  -775,  1529, -1394,   966,  -846,  1379,  -261,
                     533,  -516,   664, -1293,   824,  -966,  -833, -1757,
                     -575,  -426, -1451, -1049,  -500, -2091,  -403, -2125,
                     -1756, -3222,   325,  -195,   680, -1237,  -488, -1304,
                     1933,   186,   412,  1007,  2722,   500,  2949,  1740,
                     4305,  2520,  3714,  2732,  4187,  2919,  2899,  1663,
                     1162,  1858,  1586,  1366,  2317,   442,   530,  -126,
                     1387,   172,  1574,  1020,   724,   548,   861,   208,
                     2194,  -260,  1322,  1283,  1102,   895,  1280,  1518,
//};

// Spectrum in AnnexB US band.
//int16 gsa_DECTrainBuf_AnnexB[128] = {
                              -2055, 5113, 7859, -5538, -2107, -3778,  8959, -7002,
                     2388,  1078,   876,  1549, -2084, -8115,  6766, -1197,
                     -10469,   181, -1875,  4609,  3128,  -370,  1764,  5127,
                     -9366,  3907,  5081,  2372,  1195,  6548,  5338, -5508,
                     -4643, -3890,-11542,  1178,  2934, -7352,  2402,  2633,
                        6917,  6031, -6185, -3765,  5079, -6403, -6043,  8046,
                        6178,  -542,  3947, -1345,  6739, -7939, -6241,  5935,
                        -5933,   361,  -916, -6101, -3403,   251,  5040,  6820,
                        -669,  3963,  4147, -4559,  8967,  -419, -6640, -8109,
                        -1235,  8419, -8732,  3761,  3475, -5524,  5254, -4188,
                        -10443,-15938, 10182, 16260,  9692,  1139, -9566, -5190,
                        9602,  4125,-15663,  5181,  1953, -8354, -2151, -1282,
                        8665,  2826,   858,  3286,  8003,  6210, -1734, -4538,
                        -14665,  2320, -3016,  2043, 11418, -3562, -3775, -6555,
                        8072, -1670,  9966,  7628, -1777,  1088, -3879, -4425,
                        7084,-10933, -5574,  6091, -9186,  3317, -6068, 13485 ,
//};

//int16 gsa_DECCorrBuf_AnnexB[128] = {
                              1328,   358,  1739, -1041,   271, -1254,   705, -1753,
                     -349, -1001,  -779,  -672, -1140, -1016,  -251,   309,
                     -1576,  1205,  -522,  2325,   177,  2429,   195,  3220,
                     -817,  3105,   319,  2666,  -316,  2499,  -281,   715,
                     -1483,   118, -2289,  -109,  -987, -1422,  -828,  -887,
                     -22,  -757,  -659, -1654,   968, -1795,   565,  -345,
                     2167,  -973,  2309,  -940,  2716, -1487,  1517,  -241,
                     1363,  -775,  1529, -1394,   966,  -846,  1379,  -261,
                     533,  -516,   664, -1293,   824,  -966,  -833, -1757,
                     -575,  -426, -1451, -1049,  -500, -2091,  -403, -2125,
                     -1756, -3222,   325,  -195,   680, -1237,  -488, -1304,
                     1933,   186,   412,  1007,  2722,   500,  2949,  1740,
                     4305,  2520,  3714,  2732,  4187,  2919,  2899,  1663,
                     1162,  1858,  1586,  1366,  2317,   442,   530,  -126,
                     1387,   172,  1574,  1020,   724,   548,   861,   208,
                     2194,  -260,  1322,  1283,  1102,   895,  1280,  1518,
//};

// Spectrum in AnnexL Mask1 US band.
//int16 gsa_DECTrainBuf_AnnexL_Mask1[128] =
//{
 -1457,
  3626,
  5574,
 -3928,
 -1494,
 -2679,
  6354,
 -4966,
  1694,
   765,
   621,
  1099,
 -1478,
 -5755,
  4799,
  -849,
 -7425,
   128,
 -1330,
  3269,
  2218,
  -262,
  1251,
  3636,
 -6643,
  2771,
  3604,
  1682,
   848,
  4644,
  3786,
 -3906,
 -3293,
 -2759,
 -8186,
   835,
  2081,
 -5214,
  1704,
  1867,
  4906,
  4277,
 -4387,
 -2670,
  3602,
 -4541,
 -4286,
  5706,
  4382,
  -384,
  2799,
  -954,
  4779,
 -5630,
 -4426,
  4209,
 -4208,
   256,
  -650,
 -4327,
 -2413,
   178,
  3574,
  4837,
  -474,
  2811,
  2941,
 -3233,
  6360,
  -297,
 -4709,
 -5751,
  -876,
  5971,
 -6193,
  2667,
  2465,
 -3918,
  3726,
 -2970,
 -7406,
-11304,
  7221,
 11532,
  6874,
   808,
 -6784,
 -3681,
  6810,
  2926,
-11109,
  3674,
  1385,
 -5925,
 -1526,
  -909,
  6145,
  2004,
   609,
  2330,
  5676,
  4404,
 -1230,
 -3218,
-10401,
  1645,
 -2139,
  1449,
  8098,
 -2526,
 -2677,
 -4649,
  5725,
 -1184,
  7068,
  5410,
 -1260,
   772,
 -2751,
 -3138,
  5024,
 -7754,
 -3953,
  4320,
 -6515,
  2352,
 -4304,
  9564,
//};

//int16 gsa_DECCorrBuf_AnnexL_Mask1[128] =
//{
  1872,
   505,
  2452,
 -1468,
   382,
 -1768,
   994,
 -2472,
  -492,
 -1411,
 -1098,
  -948,
 -1607,
 -1433,
  -354,
   436,
 -2222,
  1699,
  -736,
  3278,
   250,
  3425,
   275,
  4540,
 -1152,
  4378,
   450,
  3759,
  -446,
  3524,
  -396,
  1008,
 -2091,
   166,
 -3227,
  -154,
 -1392,
 -2005,
 -1167,
 -1251,
   -31,
 -1067,
  -929,
 -2332,
  1365,
 -2531,
   797,
  -486,
  3055,
 -1372,
  3256,
 -1325,
  3830,
 -2097,
  2139,
  -340,
  1922,
 -1093,
  2156,
 -1966,
  1362,
 -1193,
  1944,
  -368,
   752,
  -728,
   936,
 -1823,
  1162,
 -1362,
 -1175,
 -2477,
  -811,
  -601,
 -2046,
 -1479,
  -705,
 -2948,
  -568,
 -2996,
 -2476,
 -4543,
   458,
  -275,
   959,
 -1744,
  -688,
 -1839,
  2726,
   262,
   581,
  1420,
  3838,
   705,
  4158,
  2453,
  6070,
  3553,
  5237,
  3852,
  5904,
  4116,
  4088,
  2345,
  1638,
  2620,
  2236,
  1926,
  3267,
   623,
   747,
  -178,
  1956,
   243,
  2219,
  1438,
  1021,
   773,
  1214,
   293,
  3094,
  -367,
  1864,
  1809,
  1554,
  1262,
  1805,
  2140,
//};

// Spectrum in AnnexL Mask2 US band.
//int16 gsa_DECTrainBuf_AnnexL_Mask2[128] =
//{
   6964,
   6168,
   3957,
   273,
   -2058,
   -3010,
   -1703,
   -579,
   1635,
   2888,
   2705,
   1049,
   -1665,
   -4313,
   -5212,
   -5579,
   -4630,
   -1493,
   1109,
   3269,
   3279,
   2264,
   696,
   -241,
   -849,
   1660,
   4109,
   6459,
   7040,
   6041,
   2367,
   -2607,
   -7026,
   -9330,
   -9751,
   -6690,
   -2686,
   983,
   4365,
   5693,
   5100,
   2471,
   -922,
   -2947,
   -2977,
   -2606,
   -150,
   2923,
   4753,
   4651,
   4076,
   2011,
   441,
   -2252,
   -3156,
   -3426,
   -4166,
   -4376,
   -4133,
   -3881,
   -1961,
   427,
   3444,
   5569,
   6482,
   6467,
   4913,
   1988,
   -214,
   -3119,
   -4628,
   -4463,
   -2539,
   -301,
   555,
   1312,
   301,
   -2361,
   -4269,
   -6037,
   -5642,
   -3096,
   2106,
   6261,
   7949,
   6957,
   4530,
   1745,
   -442,
   -3525,
   -5976,
   -5735,
   -4885,
   -3536,
   -532,
   2390,
   5215,
   6236,
   6512,
   6088,
   4849,
   2158,
   -1018,
   -3805,
   -5438,
   -4789,
   -3643,
   -1646,
   384,
   877,
   1630,
   2419,
   3990,
   4324,
   5017,
   4621,
   3212,
   1733,
   -257,
   -2221,
   -3824,
   -6399,
   -6756,
   -5711,
   -4101,
   -470,
   2971,
   6365,
//};

//int16 gsa_DECCorrBuf_AnnexL_Mask2[128] =
//{
   -14651,
   2158,
   14578,
   -16258,
   6202,
   -9577,
   22387,
   -22479,
   9759,
   -4108,
   -893,
   3977,
   -2185,
   -12991,
   14506,
   4843,
   -16813,
   11547,
   -9526,
   9244,
   -1156,
   1489,
   -6502,
   19882,
   -21717,
   12780,
   1550,
   2902,
   -11798,
   11345,
   2175,
   -4560,
   -1352,
   6557,
   -16066,
   11967,
   5866,
   -15756,
   4794,
   -3487,
   3151,
   6136,
   -8725,
   -7307,
   17373,
   -10252,
   -6135,
   5707,
   9629,
   -13935,
   11835,
   -13403,
   20892,
   -15077,
   -1087,
   9692,
   -6090,
   1855,
   6314,
   -6981,
   745,
   -3529,
   5928,
   3006,
   -4097,
   -3237,
   8456,
   -17010,
   17119,
   -337,
   -4802,
   -9527,
   -302,
   20329,
   -21517,
   5827,
   3150,
   -15887,
   17442,
   -226,
   -3333,
   -29815,
   21033,
   6455,
   2335,
   -2261,
   -12938,
   -8108,
   20287,
   8632,
   -28640,
   15213,
   12581,
   -13212,
   7818,
   -9002,
   16467,
   -3628,
   3430,
   -4132,
   7108,
   7117,
   -281,
   6052,
   -18307,
   18108,
   -5537,
   -2478,
   18513,
   -10084,
   1022,
   -9866,
   16365,
   -15717,
   13074,
   2973,
   -7296,
   4196,
   134,
   -9959,
   22775,
   -15366,
   -4457,
   19439,
   -13399,
   11859,
   -17411,
   22804
//};


};// gsa_EC_Train_Seq

DATA_MAP_END
#endif   //ADSL_62
