/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 2002 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/****************************************************************************
;  Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413
;  Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;
;  File Name: pn_tab.c
;
;  Definitions of Pseudorandom bit sequences.
;
*****************************************************************************/
#include "typedef.h"

// Pseudorandom bit sequence used for g.992.1/g.992.3/g992.5 downstream Reverb.
// Generated by the rules:
// d_n = 1,             for n=1 to 9
// d_n = d_{n-4} XOR d_{n-9}, for n=10 to 512
// The least significant bit (LSB) of the first 16-bit value in the array is d_0, the most significant bit (MSB) is d_15.
// The LSB of the second 16-bit value is d_16, the MSB is d_31, and so on.
//
uint16 gusa_PN_US_Tab[8] = { 0x083f, 0xbca3, 0x6938, 0xab37, 0x841f, 0x5e51, 0xb49c, 0xd59b};

// Pseudorandom bit sequence used for g.992.1/g.992.3 upstream Reverb.
// Generated by the rules:
// d_n = 1,             for n=1 to 6
// d_n = d_{n-5} XOR d_{n-6}  for n=7 to 64
// The least significant bit (LSB) of the first 16-bit value in the array is d_0, the most significant bit (MSB) is d_15.
// The LSB of the second 16-bit value is d_16, the MSB is d_31, and so on.
//
//uint16 gusa_PN512Tab[32] = {
//    0xe1ff,     0x9a1d,     x85ed,      x2433,      x7aea,      x39d2,      x9770,      x0a57,
//    x7d54,      xd82d,      x0d6d,      x8fba,      x5967,      xa2c7,      x34bf,      x18ca,
//    x5330,      xdf93,      xec92,      x15a7,      xdc8a,      x86f4,      x4e55,      x2118,
//    xc440,      xd5c4,      x91c6,      xcd8a,      xd1e7,      x094e,      x1732,      x83df
//}
