@echo off
rem **COPYRIGHT*****************************************************************
rem    INTEL CONFIDENTIAL
rem    Copyright (C) 2017 Intel Corporation
rem *****************************************************************COPYRIGHT**
rem **DISCLAIMER****************************************************************
rem  The source code contained or described herein and all documents related
rem  to the source code ("Material") are owned by Intel Corporation or its
rem  suppliers or licensors. Title to the Material remains with Intel
rem  Corporation or its suppliers and licensors. The Material may contain
rem  trade secrets and proprietary and confidential information of Intel
rem  Corporation and its suppliers and licensors, and is protected by
rem  worldwide copyright and trade secret laws and treaty provisions. No part
rem  of the Material may be used, copied, reproduced, modified, published,
rem  uploaded, posted, transmitted, distributed, or disclosed in any way
rem  without Intel's prior express written permission.
rem
rem  No license under any patent, copyright, trade secret or other
rem  intellectual property right is granted to or conferred upon you by
rem  disclosure or delivery of the Materials, either expressly, by
rem  implication, inducement, estoppel or otherwise. Any license under
rem  such intellectual property rights must be express and approved by
rem  Intel in writing.
rem ****************************************************************DISCLAIMER**
@echo on
REM=================================================================
REM      build_Amazon_SE.bat
REM
REM	Top level script for building the Annex B binary for the AmazonSE target HW.
REM========================================================================

setlocal

@if /I "%1" == "no_timestamp" set SKIP_BUILD_TIMESTAMP=%1

set TARGET_OPT=TARGET_HW

rem for asim build the extension will be SIM, for HW build, it's null
set TARGET_EXT=

set ITUX=ModemHWE


rem Processor and cache type; for ARC4 (4) and ARC6 (6)
set ARC_OPT=ARC6
set ARC6_VER=7_4_3
set CACHE_OPT=USE_CACHE
set MEM_MAP=AMAZON_SE_MEM

rem HW EngineLib Version: SOC and STRATIFY lib=3.0, HERC lib=5.0
set LIB_VER=4.5
set MSVC_CFG=Release

rem AFE specific
set AFE_OPT=DANUBE_AFE

rem gmake -f project.mak test

rem passing *.cmd file for sleep build
set CODESWAP_CMD_INFILE=harvardArch_biscs.cmd
set CODESWAP_MEM_INFILE=AMAZON_SE.mem
rem set EXTRA_COMPILE_OPTIONS=-DDANUBE_TEMP
set ARC_COMPILER_OPTIONS=ModemHWEcf.rsp
set EXTRA_COMPILE_OPTIONS=-DDANUBE_TEMP -DAMAZON_SE -DISDN
set EXTRA_COMPILE_OPTIONS=-DUSE_ENGINE_FOR_BG_FFTS 

call .\build_codeswap_hw.bat

rem Copy ModemHWE.bin & ModemHWE.out to new names with version info attached
perl perl\gen_target_version.pl AmazonSE ISDN
