# **COPYRIGHT*******************************************************************
#    INTEL CONFIDENTIAL
#    Copyright (C) 2017 Intel Corporation
# *******************************************************************COPYRIGHT**
# **DISCLAIMER******************************************************************
#    The source code contained or described herein and all documents related
#    to the source code ("Material") are owned by Intel Corporation or its
#    suppliers or licensors. Title to the Material remains with Intel
#    Corporation or its suppliers and licensors. The Material may contain
#    trade secrets and proprietary and confidential information of Intel
#    Corporation and its suppliers and licensors, and is protected by
#    worldwide copyright and trade secret laws and treaty provisions. No part
#    of the Material may be used, copied, reproduced, modified, published,
#    uploaded, posted, transmitted, distributed, or disclosed in any way
#    without Intel's prior express written permission.
#
#    No license under any patent, copyright, trade secret or other
#    intellectual property right is granted to or conferred upon you by
#    disclosure or delivery of the Materials, either expressly, by
#    implication, inducement, estoppel or otherwise. Any license under
#    such intellectual property rights must be express and approved by
#    Intel in writing.
# ******************************************************************DISCLAIMER**


    foreach $file (glob "*.src")
    {
        open(SRC_FILE, "<$file") || die ("Failed to open src file ($file)\n");
        $src_list_start = 0;
        while (<SRC_FILE>)
        {
            if (/\w+_SRC\s*[+]*=\s*\\/)
            {
                $src_list_start = 1;
            }
            elsif (/^\s*$/)
            {
                $src_list_start = 0;
            }

            if (($src_list_start) && (/(\S+[\\\/])(\w+\.[cs])\s*\\/))
            {
                ($temp2 = $2) =~ tr/A-Z/a-z/;
                $src_file_with_path{$temp2} = $1 . $2;
            }
        }
    }

    open(IN_FILE, "<junk.txt") || die "can't open junk.txt\n";

    while (<IN_FILE>)
    {
        if (m/([\/]+)\s*(\w+)\.o\s*(\S*.*)/)
        {
            $comment = $1;
            $comment2 = $3;
                    ($temp1 = "$2.c") =~ tr/A-Z/a-z/;
                    ($temp2 = "$2.s") =~ tr/A-Z/a-z/;
                    if (defined($src_file_with_path{$temp1}))
                    {
                        ($temp3 = $src_file_with_path{$temp1}) =~ s%\S+/(\w+)\.[cs]%$1.o%;
                        print "    $comment$temp3(.text)    $comment2\n";
                    }
                    elsif (defined($src_file_with_path{$temp2}))
                    {
                        ($temp3 = $src_file_with_path{$temp2}) =~ s%\S+/(\w+)\.[cs]%$1.o%;
                        print "    $comment$temp3(.text)    $comment2\n";
                    }
                    else
                    {
                        print(">>>>> $_");
                    }
        }
        elsif (m/^\s*(\w+)\.o\s*(\S*.*)/)
        {
            $comment2 = $3;
                    ($temp1 = "$1.c") =~ tr/A-Z/a-z/;
                    ($temp2 = "$1.s") =~ tr/A-Z/a-z/;
                    if (defined($src_file_with_path{$temp1}))
                    {
                        ($temp3 = $src_file_with_path{$temp1}) =~ s%\S+/(\w+)\.[cs]%$1.o%;
                        print "    $temp3(.text)    $comment2\n";
                    }
                    elsif (defined($src_file_with_path{$temp2}))
                    {
                        ($temp3 = $src_file_with_path{$temp2}) =~ s%\S+/(\w+)\.[cs]%$1.o%;
                        print "    $temp3(.text)    $comment2\n";
                    }
                    else
                    {
                        print(">>>>> $_");
                    }
        }
        elsif (m/^\s*(\d+):/)
        {
            print ".BG_CACHE_$1_MULT_DEF: {\n";
        }
        else
        {
            print $_;
        }
    }
