;; **COPYRIGHT******************************************************************
;;    INTEL CONFIDENTIAL
;;    Copyright (C) 2017 Intel Corporation
;;    Copyright (C), 1994-2002 Aware Inc. All Rights Reserved.
;; ******************************************************************COPYRIGHT**
;; **DISCLAIMER*****************************************************************
;;   The source code contained or described herein and all documents related
;;   to the source code ("Material") are owned by Intel Corporation or its
;;   suppliers or licensors. Title to the Material remains with Intel
;;   Corporation or its suppliers and licensors. The Material may contain
;;   trade secrets and proprietary and confidential information of Intel
;;   Corporation and its suppliers and licensors, and is protected by
;;   worldwide copyright and trade secret laws and treaty provisions. No part
;;   of the Material may be used, copied, reproduced, modified, published,
;;   uploaded, posted, transmitted, distributed, or disclosed in any way
;;   without Intels prior express written permission.
;;
;;   No license under any patent, copyright, trade secret or other
;;   intellectual property right is granted to or conferred upon you by
;;   disclosure or delivery of the Materials, either expressly, by
;;   implication, inducement, estoppel or otherwise. Any license under
;;   such intellectual property rights must be express and approved by
;;   Intel in writing.
;; *****************************************************************DISCLAIMER**
;*************************************************************************
; Aware DMT Technology. Proprietary and Confidential.
;
; ADDRESS:         40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
; TELEPHONE:       781.276.4000
; FAX:             781.276.4001
; WEB:             http://www.aware.com
;
; FILENAME:        int_tables.s
;
; DESCRIPTION:     Setup service routines for interrupts
;
;*************************************************************************

.global reset
.global mem_ex
.global ins_err
.global dma_complete
.global adsl_int
.global mailbox_complete
.global reserved_int1
.global reserved_int2
.global codeswap_int
.global expansion_bus
.global xdma_done

.extern _start
.extern mem_service
.extern instr_service
.extern adsl_interrupt_handler
.extern dma_complete_handler
.extern mailbox_complete_handler
.extern reserved_int
.extern codeswap_handler
.extern expansion_bus_handler



reset:            j _start                       ; vec0

mem_ex:           j mem_service                  ; vec1

ins_err:          j instr_service                ; vec2

adsl_int:         j adsl_interrupt_handler       ; vec3

dma_complete:     j dma_complete_handler         ; vec4

mailbox_complete: j mailbox_complete_handler     ; vec5

reserved_int1:    j reserved_int                 ; vec6

reserved_int2:    j reserved_int                 ; vec7

codeswap_int:     j codeswap_handler             ; vec8

expansion_bus:    j expansion_bus_handler        ; vec9

xdma_done:        j dma_complete_handler         ; veca







