/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/////////// LIST OF IMPORTED FUNCTIONS FROM DIFF SWAP PAGES ////////////////

// ALGHD page should not have any imported functions.

/////////// LIST OF EXPORTED FUNCTIONS FROM THIS SWAP PAGES ////////////////

// ComplexMult.c
#pragma Alias(ComplexMult, "ComplexMult_AlgHd3V2Swap")

// FdqHandler.c
#pragma Alias(FdqHandler, "FdqHandler_AlgHd3V2Swap")


// IRI_IOf_mfdq.c
#pragma Alias(ReadSfdqCoef, "ReadSfdqCoef_AlgHd3V2Swap")
#pragma Alias(WriteSfdqCoef, "WriteSfdqCoef_AlgHd3V2Swap")
#pragma Alias(ReadMfdqCoef, "ReadMfdqCoef_AlgHd3V2Swap")
#pragma Alias(WriteMfdqCoef, "WriteMfdqCoef_AlgHd3V2Swap")
#pragma Alias(EnableMfdq, "EnableMfdq_AlgHd3V2Swap")
#pragma Alias(DisableMfdq, "DisableMfdq_AlgHd3V2Swap")
#pragma Alias(SetUpHwForMfdqHandler, "SetUpHwForMfdqHandler_AlgHd3V2Swap")
#pragma Alias(GetRxDataForMfdqHandler, "GetRxDataForMfdqHandler_AlgHd3V2Swap")

// IRI_IOf_train.c
#pragma Alias(InsertTxCE, "InsertTxCE_AlgHd3V2Swap")
#pragma Alias(InsertRxCE, "InsertRxCE_AlgHd3V2Swap")
//#pragma Alias(RestoreRxWindowCoeffSize,"RestoreRxWindowCoeffSize_AlgHd3V2Swap")
#pragma Alias(ModifyMedleyPrbsSkipBits, "ModifyMedleyPrbsSkipBits_AlgHd3V2Swap")
#pragma Alias(ConfigRxNumTone, "ConfigRxNumTone_AlgHd3V2Swap")
#pragma Alias(SwitchToTxMedleyPRBS, "SwitchToTxMedleyPRBS_AlgHd3V2Swap")
#pragma Alias(SwitchToRxMedleyPRBS, "SwitchToRxMedleyPRBS_AlgHd3V2Swap")
#pragma Alias(ConfigRTVBuf0_FFT_OUT, "ConfigRTVBuf0_FFT_OUT_AlgHd3V2Swap")
#pragma Alias(ConfigRTVBuf1_SFDQ_OUT, "ConfigRTVBuf1_SFDQ_OUT_AlgHd3V2Swap")
#pragma Alias(ConfigRTVBuf1_ERR_OUT, "ConfigRTVBuf1_ERR_OUT_AlgHd3V2Swap")
//#pragma Alias(LoadBlackoutNssiBits, "LoadBlackoutNssiBits_AlgHd3V2Swap")
//#pragma Alias(DisablePrbsGen, "DisablePrbsGen_AlgHd3V2Swap")
//#pragma Alias(EnablePrbsGen, "EnablePrbsGen_AlgHd3V2Swap")

// IRI_sync.c
#pragma Alias(AdjustAlignment, "AdjustAlignment_AlgHd3V2Swap")
#pragma Alias(ResetRxAlign, "ResetRxAlign_AlgHd3V2Swap")
#pragma Alias(AdjustTxTimingAdvance, "AdjustTxTimingAdvance_AlgHd3V2Swap")
#pragma Alias(ResetTxTimingAdvance, "ResetTxTimingAdvance_AlgHd3V2Swap")



// MfdqHandler.c
#pragma Alias(MfdqHandler, "MfdqHandler_AlgHd3V2Swap")


// SnrFrameAlignHandler.c
#pragma Alias(SnrFrameAlignHandler, "SnrFrameAlignHandler_AlgHd3V2Swap")
#pragma Alias(SearchHighestSnrSum, "SearchHighestSnrSum_AlgHd3V2Swap")

// SnrHandler.c
#pragma Alias(SnrHandler, "SnrHandler_AlgHd3V2Swap")
#pragma Alias(BgSnrMedleyRestoreFdq, "BgSnrMedleyRestoreFdq_AlgHd3V2Swap")
#pragma Alias(BgSnrInit, "BgSnrInit_AlgHd3V2Swap")

// V_STR_IOf_Trn.c
#pragma Alias(UnityRxIIR, "UnityRxIIR_AlgHd3V2Swap")
#pragma Alias(LoadRxIIR, "LoadRxIIR_AlgHd3V2Swap")

#pragma Alias(LoadIir, "LoadIir_AlgHd3V2Swap")
#pragma Alias(TxLoadIir, "TxLoadIir_AlgHd3V2Swap")
#pragma Alias(RxLoadIir, "RxLoadIir_AlgHd3V2Swap")
#pragma Alias(RestoreRxIIR, "RestoreRxIIR_AlgHd3V2Swap")
#pragma Alias(UnityDecimFIR, "UnityDecimFIR_AlgHd3V2Swap")
#pragma Alias(RestoreDecimFIR, "RestoreDecimFIR_AlgHd3V2Swap")


#pragma Alias(SetRxVarGain, "SetRxVarGain_AlgHd3V2Swap")

    #pragma Alias(SetSRCFR, "SetSRCFR_AlgHd3V2Swap")

#pragma Alias(EnableSRCFilter, "EnableSRCFilter_AlgHd3V2Swap")
#pragma Alias(EnableTimeDomainLoopback, "EnableTimeDomainLoopback_AlgHd3V2Swap")
#pragma Alias(DisableTimeDomainLoopback, "DisableTimeDomainLoopback_AlgHd3V2Swap")
