/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/////////// LIST OF IMPORTED FUNCTIONS FROM DIFF SWAP PAGES ////////////////

// BitloadHandler.c
#pragma Alias(BitloadHandler, "BitloadHandler_AlgHd4V2Swap")

// FdqHandler.c
#pragma Alias(FdqHandler, "FdqHandler_AlgHd3V2Swap")

// InitShowTimeRx.c
#pragma Alias(RxShowInitHandler, "RxShowInitHandler_Anal4V2Swap")

// MfdqHandler.c
#pragma Alias(MfdqHandler, "MfdqHandler_AlgHd3V2Swap")

// SnrFrameAlignHandler.c
#pragma Alias(SnrFrameAlignHandler, "SnrFrameAlignHandler_AlgHd3V2Swap")

// SnrHandler.c
#pragma Alias(SnrHandler, "SnrHandler_AlgHd3V2Swap")
#pragma Alias(BgSnrMedleyRestoreFdq, "BgSnrMedleyRestoreFdq_AlgHd3V2Swap")
#pragma Alias(BgSnrInit, "BgSnrInit_AlgHd3V2Swap")

/////////// LIST OF EXPORTED FUNCTIONS FROM THIS SWAP PAGES ////////////////




// IRI_IOf_mfdq.c

#pragma Alias(ReadSfdqCoef, "ReadSfdqCoef_Anal1V2Swap")
#pragma Alias(WriteSfdqCoef, "WriteSfdqCoef_Anal1V2Swap")
#pragma Alias(ReadMfdqCoef, "ReadMfdqCoef_Anal1V2Swap")
#pragma Alias(WriteMfdqCoef, "WriteMfdqCoef_Anal1V2Swap")
#pragma Alias(EnableMfdq, "EnableMfdq_Anal1V2Swap")
#pragma Alias(DisableMfdq, "DisableMfdq_Anal1V2Swap")
#pragma Alias(SetUpHwForMfdqHandler, "SetUpHwForMfdqHandler_Anal1V2Swap")
#pragma Alias(GetRxDataForMfdqHandler, "GetRxDataForMfdqHandler_Anal1V2Swap")


// IRI_sync.c
#pragma Alias(AdjustAlignment, "AdjustAlignment_Anal1V2Swap")
#pragma Alias(ResetRxAlign, "ResetRxAlign_Anal1V2Swap")
#pragma Alias(AdjustTxTimingAdvance, "AdjustTxTimingAdvance_Anal1V2Swap")
#pragma Alias(ResetTxTimingAdvance, "ResetTxTimingAdvance_Anal1V2Swap")

// MedleyMsgCheckRxTimer.c
#pragma Alias(MedleyMsgCheckRxTimer, "MedleyMsgCheckRxTimer_Anal1V2Swap")

// MedleyTrainingRxF.c
#pragma Alias(MedleyTrainRxF, "MedleyTrainRxF_Anal1V2Swap")


// nomatp.c
//#pragma Alias(CalcInitNOMATP, "CalcInitNOMATP_Anal1V2Swap");
//#pragma Alias(CalcLinearPsdTable, "CalcLinearPsdTable_Anal1V2Swap");
//#pragma Alias(CalcLinearMAXNOMATP, "CalcLinearMAXNOMATP_Anal1V2Swap");
//#pragma Alias(CalcNOMATP, "CalcNOMATP_Anal1V2Swap");
//#pragma Alias(InterpolatePsd, "InterpolatePsd_Anal1V2Swap");
//#pragma Alias(CalcLinearPsd, "CalcLinearPsd_Anal1V2Swap");
//#pragma Alias(UpdateNOMATP, "UpdateNOMATP_Anal1V2Swap");
//#pragma Alias(CalcFinalNOMATP, "CalcFinalNOMATP_Anal1V2Swap");
//#pragma Alias(CheckNOMATPLimit, "CheckNOMATPLimit_Anal1V2Swap");
//#pragma Alias(SignedAccum48, "SignedAccum48_Anal1V2Swap");

// ReorderTRT.c
#pragma Alias(ReorderTRT_Rx, "ReorderTRT_Rx_Anal1V2Swap");
#pragma Alias(ReorderTRT_Tx, "ReorderTRT_Tx_Anal1V2Swap");
#pragma Alias(ReadTRT, "ReadTRT_Anal1V2Swap");
#pragma Alias(WriteTRT, "WriteTRT_Anal1V2Swap");
#pragma Alias(FillUnusedToneInTRT, "FillUnusedToneInTRT_Anal1V2Swap");
#pragma Alias(Unpack_TRT, "Unpack_TRT_Anal1V2Swap");
#pragma Alias(ReorderTones, "ReorderTones_Anal1V2Swap");


// ResetPRBS.c
#pragma Alias(EnableTxResetPRBS, "EnableTxResetPRBS_Anal1V2Swap")
#pragma Alias(EnableRxResetPRBS, "EnableRxResetPRBS_Anal1V2Swap")

// for TimingAdvanceHandler.c
#pragma Alias(SavePreTimeAdvanceInfo, "SavePreTimeAdvanceInfo_Anal1V2Swap")
#pragma Alias(SavePostTimeAdvanceInfo, "SavePostTimeAdvanceInfo_Anal1V2Swap")
#pragma Alias(TimingAdvanceHandler, "TimingAdvanceHandler_Anal1V2Swap")




/////////// LIST OF MAPPED FUNCTIONS FROM ANAL4  ////////////////

//#pragma Alias(InitShowTimeTxVars, "InitShowTimeTxVars_Anal4Swap")

/////////// LIST OF IMPORTED FUNCTIONS FROM DIFF SWAP PAGES ////////////////

/////////// ANAL_2_V2 //////////
// for SnrFrameAlignHandler.c
//#pragma Alias(SnrFrameAlignHandler, "SnrFrameAlignHandler_Anal2V2Swap")
//#pragma Alias(SearchHighestSnrSum, "SearchHighestSnrSum_Anal2V2Swap")

// for MfdqHandler.c
//#pragma Alias(MfdqHandler, "MfdqHandler_Anal2V2Swap")

// for BitloadHandler.c
//#pragma Alias(BitloadHandler, "BitloadHandler_Anal3V2Swap")

// for Bitload.c
//#pragma Alias(InitBitloading, "InitBitloading_Anal3V2Swap")
//#pragma Alias(BgInitBitloading, "BgInitBitloading_Anal3V2Swap")
//#pragma Alias(BitloadAdaptiveRate, "BitloadAdaptiveRate_Anal3V2Swap")
//#pragma Alias(BitloadFixedRate, "BitloadFixedRate_Anal3V2Swap")
//#pragma Alias(BgBitloadAdaptiveRate, "BgBitloadAdaptiveRate_Anal3V2Swap")
//#pragma Alias(BgBitloadExplicitRate, "BgBitloadExplicitRate_Anal3V2Swap")
//#pragma Alias(ComputeSNRM_NOMATP, "ComputeSNRM_NOMATP_Anal3V2Swap")

// for InitShowTimeRx.c
//#pragma Alias(RxShowInitHandler, "RxShowInitHandler_Anal4V2Swap")
//#pragma Alias(BgInitShowTimeRx, "BgInitShowTimeRx_Anal4V2Swap")
//#pragma Alias(InitShowTimeRxVars, "InitShowTimeRxVars_Anal4V2Swap")
//#pragma Alias(RxIbInit, "RxIbInit_Anal4V2Swap")




/////////// LIST OF MAPPED FUNCTIONS FROM ANAL 5 V2  ////////////////
// for InitShowTimeTx.c
#pragma Alias(TxShowInitHandler, "TxShowInitHandler_Anal5V2Swap")

// for RMedleyMsg2TxF_VDSL2.c
#pragma Alias(RMedleyMsg2TxF_VDSL2, "RMedleyMsg2TxF_VDSL2_Anal5V2Swap")




/////////// LIST OF EXPORTED FUNCTIONS FROM THIS SWAP PAGES ////////////////

// for MedleyTrainingRxF.c
#pragma Alias(MedleyTrainRxF, "MedleyTrainRxF_Anal1V2Swap")

// for RMedleyMsgTxF_VDSL2.c
#pragma Alias(RMedleyMsgTxF_VDSL2, "RMedleyMsgTxF_VDSL2_Anal1V2Swap")

// for RMedleyMsgHandler.c
#pragma Alias(RMedleyMsgHandler, "RMedleyMsgHandler_Anal1V2Swap")

// for FormRMsg2Msg_VDSL2.c
#pragma Alias(FormRMsg2Msg_VDSL2, "FormRMsg2Msg_VDSL2_Anal1V2Swap")

// for ROPmdRxF_VDSL2.c
#pragma Alias(ROPmdRxF_VDSL2, "ROPmdRxF_VDSL2_Anal1V2Swap")

// for InsertCE.c
#pragma Alias(DisableTxCE,"DisableTxCE_Anal1V2Swap")
#pragma Alias(DisableRxCE,"DisableRxCE_Anal1V2Swap")
#pragma Alias(ChangeTxCE_ForFirstSym, "ChangeTxCE_ForFirstSym_Anal1V2Swap")
#pragma Alias(ChangeRxCE_ForFirstSym, "ChangeRxCE_ForFirstSym_Anal1V2Swap")
#pragma Alias(ChangeTxCE_ForLastSym,  "ChangeTxCE_ForLastSym_Anal1V2Swap")
#pragma Alias(ConfigTxFrameSize,      "ConfigTxFrameSize_Anal1V2Swap")
#pragma Alias(ConfigRxFrameSize,      "ConfigRxFrameSize_Anal1V2Swap")
#pragma Alias(ChangeRxFftLength_ForLastSym, "ChangeRxFftLength_ForLastSym_Anal1V2Swap")
#pragma Alias(ChangeRxCE_PreFirstSym, "ChangeRxCE_PreFirstSym_Anal1V2Swap")
#pragma Alias(ChangeRxFftLength_PreLastSym, "ChangeRxFftLength_PreLastSym_Anal1V2Swap")


