/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/////////// LIST OF IMPORTED FUNCTIONS FROM DIFF SWAP PAGES ////////////////



/////////// LIST OF EXPORTED FUNCTIONS FROM THIS SWAP PAGES ////////////////



// for rx_ib.c
#pragma Alias(UpdateAtmPrimitive_FE, "UpdateAtmPrimitive_FE_Show1Swap")
#pragma Alias(UpdateLineFailurePrimitive_FE, "UpdateLineFailurePrimitive_FE_Show1Swap")
#pragma Alias(UpdateG997Counters, "UpdateG997Counters_Show1Swap")
#pragma Alias(RxIbHandler, "RxIbHandler_Show1Swap")

// for tx_ib.c
#pragma Alias(DefectGeneration, "DefectGeneration_Show1Swap")
#pragma Alias(UpdateAtmPrimitive_NE, "UpdateAtmPrimitive_NE_Show1Swap")
#pragma Alias(UpdateLineFailurePrimitive_NE, "UpdateLineFailurePrimitive_NE_Show1Swap")
#pragma Alias(UpdateTCSyncState, "UpdateTCSyncState_Show1Swap")
#pragma Alias(TxIbHandler, "TxIbHandler_Show1Swap")

// for g997.c
#pragma Alias(G997_SuperFrame_Task, "G997_SuperFrame_Task_Show1Swap")
#pragma Alias(G997_FailureCounterUpdate, "G997_FailureCounterUpdate_Show1Swap")
#pragma Alias(G997_CheckRxFailure, "G997_CheckRxFailure_Show1Swap")
#pragma Alias(G997_CheckTxFailure, "G997_CheckTxFailure_Show1Swap")
#pragma Alias(G997_CheckUsMargin, "G997_CheckUsMargin_Show1Swap")
#pragma Alias(SetTwoBits, "SetTwoBits_Show1Swap")
#pragma Alias(ProcessG997Failures, "ProcessG997Failures_Show1Swap")

// for show_iof.c
#pragma Alias(EnableTxXtc, "EnableTxXtc_Show1Swap")
#pragma Alias(EnableRxXtc, "EnableRxXtc_Show1Swap")
#pragma Alias(StartTxDataPath, "StartTxDataPath_Show1Swap")
#pragma Alias(StartRxDataPath, "StartRxDataPath_Show1Swap")
#pragma Alias(ReadCRCErrors, "ReadCRCErrors_Show1Swap")
#pragma Alias(ReadRSCorrections, "ReadRSCorrections_Show1Swap")
#pragma Alias(GetTxATMCellCnts, "GetTxATMCellCnts_Show1Swap")
#pragma Alias(GetRxATMCellCnts, "GetRxATMCellCnts_Show1Swap")
#pragma Alias(TxSuperFrameTaskPerPath, "TxSuperFrameTaskPerPath_Show1Swap")
#pragma Alias(RxSuperFrameProcess, "RxSuperFrameProcess_Show1Swap")
#pragma Alias(RxSuperFrameTaskPerPath, "RxSuperFrameTaskPerPath_Show1Swap")
#pragma Alias(ReadRxFftOutput, "ReadRxFftOutput_Show1Swap")
#pragma Alias(ReadRxErrOutput, "ReadRxErrOutput_Show1Swap")
#pragma Alias(EnableTxFcTimerStart, "EnableTxFcTimerStart_Show1Swap")
#pragma Alias(EnableRxFcCascadeStart, "EnableRxFcCascadeStart_Show1Swap")
#pragma Alias(DisableRxFcCascadeStart, "DisableRxFcCascadeStart_Show1Swap")
#pragma Alias(DisableRxPRBS, "DisableRxPRBS_Show1Swap")
#ifdef DEBUG_SHOWTIME
#pragma Alias(LogRxBufAtRxFcTc, "LogRxBufAtRxFcTc_Show1Swap")
#endif


#ifdef ZEP_DEBUG_BLD
#pragma Alias(EnableTxFifo3Capture, "EnableTxFifo3Capture_Show1Swap")
#pragma Alias(DisableTxFifo3Capture, "DisableTxFifo3Capture_Show1Swap")
#pragma Alias(UpdateTxFifo3Stat, "UpdateTxFifo3Stat_Show1Swap")
#pragma Alias(EnableRxFifo3Capture, "EnableRxFifo3Capture_Show1Swap")
#pragma Alias(DisableRxFifo3Capture, "DisableRxFifo3Capture_Show1Swap")
#pragma Alias(UpdateRxFifo3Stat, "UpdateRxFifo3Stat_Show1Swap")
#endif //#ifdef ZEP_DEBUG_BLD



// for ResetPRBS.c
#pragma Alias(EnableTxResetPRBS, "EnableTxResetPRBS_Show1Swap")
#pragma Alias(EnableRxResetPRBS, "EnableRxResetPRBS_Show1Swap")

// for ddsnrfdq_iof.c
#pragma Alias(SetUpRTVForDDSnrFdqHandler, "SetUpRTVForDDSnrFdqHandler_Show1Swap")

#ifdef HW_SNR_FDQ

   #pragma Alias(EnableFDQAdapt, "EnableFDQAdapt_Show1Swap")
   #pragma Alias(DisableFDQAdapt, "DisableFDQAdapt_Show1Swap")
// #pragma Alias(TriggerVectorPower, "TriggerVectorPower_Show1Swap")
// #pragma Alias(DeTriggerVectorPower, "DeTriggerVectorPower_Show1Swap")
// #pragma Alias(ReadVectorPower, "ReadVectorPower_Show1Swap")
#endif


#ifdef ENABLE_SHOW_LPBK
// for show_lpbk_iof.c
#pragma Alias(ShowtimeLoopbackTC, "ShowtimeLoopbackTC_Show1Swap")
#pragma Alias(LoopbackAtDTB, "LoopbackAtDTB_Show1Swap")
#pragma Alias(LoopbackAtFFT, "LoopbackAtFFT_Show1Swap")
#pragma Alias(SetTxHwForLoopback, "SetTxHwForLoopback_Show1Swap")
#pragma Alias(SetRxHwForLoopback, "SetRxHwForLoopback_Show1Swap")
#endif

#ifdef DEBUG_TRAIL
// LeaveEocTrail.c
#pragma Alias(LeaveEOCOvhdMsgTrail, "LeaveEOCOvhdMsgTrail_Show1Swap")
#endif
