/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */

/////////// LIST OF IMPORTED FUNCTIONS FROM DIFF SWAP PAGES ////////////////


/////////// LIST OF EXPORTED FUNCTIONS FROM THIS SWAP PAGES ////////////////
// for snrhandler.c
#pragma Alias(SnrHandler, "SnrHandler_SleepSwap")
#pragma Alias(BgSnrMedleyRestoreFdq, "BgSnrMedleyRestoreFdq_SleepSwap")
#pragma Alias(BgSnrInit, "BgSnrInit_SleepSwap")


// for fdqhandler.c
#pragma Alias(FdqHandler, "FdqHandler_SleepSwap")

// for ModulateSocMessges.c
#pragma Alias(DecodeSOCMessage, "DecodeSOCMessage_SleepSwap")
#pragma Alias(ModulateHdlcOctets, "ModulateHdlcOctets_SleepSwap")
#pragma Alias(GenerateSynSymLookUpData, "GenerateSynSymLookUpData_SleepSwap")

// for InsertCE.c
#pragma Alias(DisableTxCE,"DisableTxCE_SleepSwap")
#pragma Alias(DisableRxCE,"DisableRxCE_SleepSwap")
//#pragma Alias(RestoreRxWindowCoeffSize,"RestoreRxWindowCoeffSize_SleepSwap")
#pragma Alias(ChangeTxCE_ForFirstSym, "ChangeTxCE_ForFirstSym_SleepSwap")
#pragma Alias(ChangeRxCE_ForFirstSym, "ChangeRxCE_ForFirstSym_SleepSwap")
#pragma Alias(ChangeTxCE_ForLastSym,  "ChangeTxCE_ForLastSym_SleepSwap")
#pragma Alias(ConfigTxFrameSize,      "ConfigTxFrameSize_SleepSwap")
#pragma Alias(ConfigRxFrameSize,      "ConfigRxFrameSize_SleepSwap")
#pragma Alias(ChangeRxFftLength_ForLastSym, "ChangeRxFftLength_ForLastSym_SleepSwap")
#pragma Alias(ChangeRxCE_PreFirstSym, "ChangeRxCE_PreFirstSym_SleepSwap")
#pragma Alias(ChangeRxFftLength_PreLastSym, "ChangeRxFftLength_PreLastSym_SleepSwap")

// for PsdHanlder.c
#pragma Alias(PsdHandler, "PsdHandler_SleepSwap")

// for cosine.c
#pragma Alias(FastCosine, "FastCosine_SleepSwap")
#pragma Alias(FastSine, "FastSine_SleepSwap")
#pragma Alias(Modulo2PI, "Modulo2PI_SleepSwap")
#pragma Alias(RotateTone, "RotateTone_SleepSwap")

// FrameAlignmentHandler.c
#pragma Alias(BgFrameAlignSelectBand, "BgFrameAlignSelectBand_SleepSwap")
#pragma Alias(FrameAlignmentHandler, "FrameAlignmentHandler_SleepSwap")


// TimingAdvanceHandler.c
#pragma Alias(SavePreTimeAdvanceInfo, "SavePreTimeAdvanceInfo_SleepSwap")
#pragma Alias(SavePostTimeAdvanceInfo, "SavePostTimeAdvanceInfo_SleepSwap")
#pragma Alias( TimingAdvanceHandler, "TimingAdvanceHandler_SleepSwap")

// for SharedFuncs.c
#pragma Alias(ClusterIndex, "ClusterIndex_SleepSwap")
#pragma Alias(CalcTxRxFrameOffset, "CalcTxRxFrameOffset_SleepSwap")


// AddPsdBrkpt.c
#pragma Alias(AddPsdBrkpt, "AddPsdBrkpt_SleepSwap")



// LoadIridiaTransmitGains.c
#pragma Alias(LoadIridiaTransmitGains, "LoadIridiaTransmitGains_SleepSwap")

// for LoadTransmitGains.c
#pragma Alias(LoadTransmitGains, "LoadTransmitGains_SleepSwap")




// for PGAhandler.c
#pragma Alias(PGAHandler, "PGAHandler_SleepSwap")
#pragma Alias(BgAdjustQlnForPga, "BgAdjustQlnForPga_SleepSwap")
#pragma Alias(InvDB, "InvDB_SleepSwap")
#pragma Alias(LoadRxVarGain, "LoadRxVarGain_SleepSwap")
#pragma Alias(ComputePLLRefAvg, "ComputePLLRefAvg_SleepSwap")

// for MfdqHandler.c
#pragma Alias(MfdqHandler, "MfdqHandler_SleepSwap")
//#pragma Alias(MfdqHandler, "MfdqHandler_Anal2Swap")

// for interrupt_control.c

#ifdef DISTRIBUTE_TX_RX_PROCESS
   #pragma Alias(DisableRxTimerInterrupt, "DisableRxTimerInterrupt_SleepSwap")
   #pragma Alias(EnableRxTimerInterrupt, "EnableRxTimerInterrupt_SleepSwap")
#endif // DISTRIBUTE_TX_RX_PROCESS

// IRI_IOf_train.c
#pragma Alias(InsertTxCE, "InsertTxCE_SleepSwap")
#pragma Alias(InsertRxCE, "InsertRxCE_SleepSwap")
#pragma Alias(ModifyMedleyPrbsSkipBits, "ModifyMedleyPrbsSkipBits_SleepSwap")
#pragma Alias(ConfigRxNumTone, "ConfigRxNumTone_SleepSwap")
#pragma Alias(SwitchToTxMedleyPRBS, "SwitchToTxMedleyPRBS_SleepSwap")
#pragma Alias(SwitchToRxMedleyPRBS, "SwitchToRxMedleyPRBS_SleepSwap")
#pragma Alias(ConfigRTVBuf0_FFT_OUT, "ConfigRTVBuf0_FFT_OUT_SleepSwap")
#pragma Alias(ConfigRTVBuf1_SFDQ_OUT, "ConfigRTVBuf1_SFDQ_OUT_SleepSwap")
#pragma Alias(ConfigRTVBuf1_ERR_OUT, "ConfigRTVBuf1_ERR_OUT_SleepSwap")
//#pragma Alias(LoadBlackoutNssiBits, "LoadBlackoutNssiBits_SleepSwap")
//#pragma Alias(DisablePrbsGen, "DisablePrbsGen_SleepSwap")
//#pragma Alias(EnablePrbsGen, "EnablePrbsGen_SleepSwap")

// IRI_sync.c
#pragma Alias(AdjustAlignment, "AdjustAlignment_SleepSwap")
#pragma Alias(ResetRxAlign, "ResetRxAlign_SleepSwap")
#pragma Alias(AdjustTxTimingAdvance, "AdjustTxTimingAdvance_SleepSwap")
#pragma Alias(ResetTxTimingAdvance, "ResetTxTimingAdvance_SleepSwap")

// for sleep_iof.c
/*
#pragma Alias(SetUpToneSignal, "SetUpToneSignal_SleepSwap")
#pragma Alias(SetUpTrainingSignal, "SetUpTrainingSignal_SleepSwap")
#pragma Alias(SetUpMedleySignal, "SetUpMedleySignal_SleepSwap")
#pragma Alias(EnableTxToRxLoopback, "EnableTxToRxLoopback_SleepSwap")
*/


// V_STR_IOf_Trn.c
#pragma Alias(UnityRxIIR, "UnityRxIIR_SleepSwap")
#pragma Alias(LoadRxIIR, "LoadRxIIR_SleepSwap")

#pragma Alias(LoadIir, "LoadIir_SleepSwap")
#pragma Alias(TxLoadIir, "TxLoadIir_SleepSwap")
#pragma Alias(RxLoadIir, "RxLoadIir_SleepSwap")
#pragma Alias(RestoreRxIIR, "RestoreRxIIR_SleepSwap")
#pragma Alias(UnityDecimFIR, "UnityDecimFIR_SleepSwap")
#pragma Alias(RestoreDecimFIR, "RestoreDecimFIR_SleepSwap")

//Reconfig_CRI.c
#pragma Alias(Reconfig_CRI, "Reconfig_CRI_SleepSwap")


#pragma Alias(SetRxVarGain, "SetRxVarGain_SleepSwap")

    #pragma Alias(SetSRCFR, "SetSRCFR_SleepSwap")

#pragma Alias(EnableSRCFilter, "EnableSRCFilter_SleepSwap")
#pragma Alias(EnableTimeDomainLoopback, "EnableTimeDomainLoopback_SleepSwap")
#pragma Alias(DisableTimeDomainLoopback, "DisableTimeDomainLoopback_SleepSwap")

// vecpwr.c
#pragma Alias(VectorPower, "VectorPower_SleepSwap")
