/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2004 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/****************************************************************************
;  Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413
;  Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;
;  File Name: OvhdMsg_IOf.h
;
;  Header file for VDSL overhead messaging HW i/o functions.
;
*****************************************************************************/
#ifndef _OVHDMSG_IOF_H
#define _OVHDMSG_IOF_H

// VDSL1 function prototypes
void WriteTxIbHwFifo(void);
void ReadRxIbHwFifo(void);
uint16 WriteTxVocSwFifo(uint8 *puca_inbuf, uint16 us_NumBytes);
void WriteTxVocHwFifo(void);
int16 ReadByteFromRxVocSwFifo(uint8 *puc_byte);
void ReadRxVocHwFifo(void);


// VDSL2 function prototypes
void WriteTxOvhdHwFifo(void);
void ReadRxOvhdHwFifo(void);
void TxOvhdHandler(void);
void RxOvhdHandler(void);


// Macros
#define TX_FIFO0_VALID_BYTES_MASK   (0x3F)
#define TX_FIFO1_VALID_BYTES_MASK   (0x3F)
#define TX_FIFO2_VALID_BYTES_MASK   (0x7)

#define RX_FIFO0_VALID_BYTES_MASK   (0x3F)
#define RX_FIFO1_VALID_BYTES_MASK   (0x3F)
#define RX_FIFO2_VALID_BYTES_MASK   (0x7)


#endif //_OVHDMSG_IOF_H
