/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2005 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
*-------------------------------------------------------------------------------
*
*   Aware DMT Technology. Proprietary and Confidential.
*
*   40 Middlesex Turnpike, Bedford, MA 01730-1413
*   Phone (781) 276 - 4000
*   Fax   (781) 276 - 4001
*
*   filename: RxDataPumpSetUp.h
*
*   Header file for RxDataPumpSetUp.c
*
*-------------------------------------------------------------------------------
*/

#ifndef _RXDATAPUMPSETUP_H
#define _RXDATAPUMPSETUP_H

// used for guc_RxDataPumpState inside RxDataPumpSetUp()
#define RX_CONFIG_TPS_ALP           (0)
#define RX_CONFIG_TPS_ELE           (1)
#define RX_CONFIG_PMS_ZEP_FC        (2)
    #define     RX_ZEP_FC_LOADING_LP0_UCODE     (21)
   #define     RX_ZEP_FC_WAIT_FOR_LP0_UCODE    (25)
    #define     RX_ZEP_FC_LOADING_LP1_UCODE     (22)
    #define     RX_ZEP_FC_WAIT_FOR_LP1_UCODE    (23)
    #define     RX_ZEP_FC_LOADING_UCODE_DONE    (24)

#define RX_CONFIG_PMS_ZEP_ILV       (3)
#define RX_CONFIG_PMD_IRI_QT        (4)
#define RX_CONFIG_CORE_START        (RX_CONFIG_TPS_ALP)
#define RX_CONFIG_CORE_DONE            (RX_CONFIG_PMD_IRI_QT+1)

void RxDataPumpSetUp(void);
void ConfigAlphaeusRxPath(void);
void ConfigBcrRxPath(void);
void ConfigZephyrFcRxPath(void);
void ConfigZephyrFcRxPath_VDSL2(void);
void ConfigZephyrIlvRxPath(void);
void ConfigZephyrIlvRxPath_VDSL2(void);
void ConfigIridiaQtRxPath(void);
void ConfigureNtrHw(void);

uint32 ConfigZephyrIlvRxDFM(void);
uint32 ConfigZephyrIlvRxDFM_VDSL2(void);

#endif // _RXDATAPUMPSETUP_H
