/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C) 2005 - Infineon Technologies
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/***C***************************************************************************
** The 'CCASE' lines will be filled by ClearCase upon checkin,
** please do not change this information manually!
**
** =============================================================================
**
** All rights reserved.
** =============================================================================
**
** =============================================================================
**
** This document contains proprietary information belonging to Infineon
** Technologies. Passing on and copying of this document, and communication of
** its contents is not permitted without prior written authorisation.
**
** =============================================================================
**
**
** =============================================================================
**
** Revision Information :
**
** CCASE_FILE = "xTC_DebugMsgHandler.h"
** CCASE_DATE = "Mon Jun  6 10:46:09 2005"
**
** =============================================================================
**
** Project:    <project/component name>
** Block:      <block/module name>
**
** =============================================================================
**
** Contents:   Definitions for file xTC_DebugMsgHandler.c
**
** =============================================================================
**
** References: <List of related design documents>
**
** =============================================================================
** History:
**
** Date         Author        Comment
** 2005-04-22   Wehmann       Creation
** =============================================================================
Additional version control information
********************************************************************************
 CCASE_USER    = "wehmann"
 CCASE_VERSION = "\main\3"
***C*E*************************************************************************/


#ifndef DMT_SCOPE_PSD_MEASURE_H  /* protect */
#define DMT_SCOPE_PSD_MEASURE_H

/*
** =============================================================================
**                           DEFINITIONS
** =============================================================================
*/

#define PSD_AVERAGE     0
#define PSD_PEAKHOLD    1
#define PSD_BOTTOMHOLD  2



extern int32 gs_PsdCalValue;

extern uint16 PsdMeasMode;
extern uint16 PsdMeasNumOfFrames;
extern uint16 PsdMeasLog2NumOfFrames;

/*
** =============================================================================
**                           TYPES
** =============================================================================
*/

/*
** =============================================================================
**                           FUNCTION PROTOTYPES
** =============================================================================
*/
/*
** =============================================================================
** FUNCTION-DESCRIPTION
**
** FUNCTION-NAME:  TestMsgHandler()
**
** DESCRIPTION:    This function executes the incoming DMT Scope Test message
**
** PARAMETERS:     MsgID (uint_16 / unsigned short)
**                 - MsgID from actual message.
**
**                 *PayLoadSize (uint_16 / unsgned short)
**                 - Pointer to payload size.
**
** RETURN VALUE:   xTCMsgExecuted (uint_8 / unsgned char)
**                 - Value for function code creation.
**
** NOTES:          Under construction!
** =============================================================================
*/
extern void PsdCalibrate();
extern void PsdMeasure(void);
extern void PsdPeakHold(int32 *pla_NoisePowerX, int16 *psa_dataXY, int16 s_num_tones);
extern void PsdBottomHold(int32 *pla_NoisePowerX, int16 *psa_dataXY, int16 s_num_tones);
extern void PsdPeakHoldLoop(int32 *pla_NoisePowerX, int16 *psa_dataXY, int16 s_num_tones);
extern void PsdBottomHoldLoop(int32 *pla_NoisePowerX, int16 *psa_dataXY, int16 s_num_tones);


#endif /* protect */
