/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C) 2004 - Infineon Technologies
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/***C***************************************************************************
** The 'CCASE' lines will be filled by ClearCase upon checkin,
** please do not change this information manually!
**
** =============================================================================
**
** All rights reserved.
** =============================================================================
**
** =============================================================================
**
** This document contains proprietary information belonging to Infineon
** Technologies. Passing on and copying of this document, and communication of
** its contents is not permitted without prior written authorisation.
**
** =============================================================================
**
**
** =============================================================================
**
** Revision Information :
**
** CCASE_FILE = "ocmem_regs.h"
** CCASE_DATE = "Mon Jan 31 17:31:35 2005"
**
** =============================================================================
**
** Project:    <project/component name>
** Block:      <block/module name>
**
** =============================================================================
**
** Contents:   <short description of what is in the file>
**
** =============================================================================
**
** References: <List of related design documents>
**
** =============================================================================
** History:
**
** Date         Author        Comment
** YYYY-MM-DD   <name>        <reason for change>
** =============================================================================
Additional version control information
********************************************************************************
 CCASE_USER    = "Kumar"
 CCASE_VERSION = "\main\4"
***C*E*************************************************************************/


#ifndef _OCMEM_REGS_H  /* protect */
#define _OCMEM_REGS_H

/*
** =============================================================================
**                           DEFINITIONS
** =============================================================================
*/


#define  OC_MEM_CTRL_ADDR            0x000E8020   // Onchip memory Control Register

   #define OC_MEM_CTRL_OCMEMFM_MASK 0x00000001
   #define OC_MEM_CTRL_ARC16EN_MASK    0x00000002
   #define OC_MEM_CTRL_OCRDLCK_MASK    0x00000004
   #define OC_MEM_CTRL_OCWRLCK_MASK    0x00000008
   #define OC_MEM_CTRL_NGRNTACC_MASK   0x00000010
   #define OC_MEM_CTRL_ACCESSRAM_MASK  0x00000020
   #define OC_MEM_CTRL_SYNCSTG_MASK    0x00000300
   #define OC_MEM_CTRL_XM_TEST_MASK    0x0000F000

/* Reset value of the register */
#define OC_MEM_CTRL_RESET_VALUE      0x187F0000

/* Register read and write Macros */
#define OC_MEM_CTRL_RegRead()       *((volatile uint_32*)((uint_32)(OC_MEM_CTRL_ADDR)))
#define OC_MEM_CTRL_RegWrite(VAL)   *((volatile uint_32*)((uint_32)(OC_MEM_CTRL_ADDR))) = (VAL)
/*
** =============================================================================
**                           TYPES
** =============================================================================
*/

/*
** =============================================================================
**                           FUNCTION PROTOTYPES
** =============================================================================
*/
extern void OCMEM_Init();
extern void OCMEM_SelectExtSRAM();
extern void OCMEM_SelectIntSRAM();

/*
** =============================================================================
** FUNCTION-DESCRIPTION
**
** FUNCTION-NAME:  <function_name>
**
** DESCRIPTION:    <description of what the function does>
**
** PARAMETERS:     <par_name_1>    [IN]|[OUT] <description of par_1>
**                 ...
**                 <par_name_n>    [IN]|[OUT] <description of par_n>
**
** RETURN VALUE:   <description of the return value if any>
**
** NOTES:          <any special information>
** =============================================================================
*/


#endif /* protect */
