/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C) 2004 - Infineon Technologies
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/***C***************************************************************************
** The 'CCASE' lines will be filled by ClearCase upon checkin,
** please do not change this information manually!
**
** =============================================================================
**
** All rights reserved.
** =============================================================================
**
** =============================================================================
**
** This document contains proprietary information belonging to Infineon
** Technologies. Passing on and copying of this document, and communication of
** its contents is not permitted without prior written authorisation.
**
** =============================================================================
**
**
** =============================================================================
**
** Revision Information :
**
** CCASE_FILE = "rom.h"
** CCASE_DATE = "Tue Apr 19 17:44:22 2005"
**
** =============================================================================
**
** Project:    <project/component name>
** Block:      <block/module name>
**
** =============================================================================
**
** Contents:   <short description of what is in the file>
**
** =============================================================================
**
** References: <List of related design documents>
**
** =============================================================================
** History:
**
** Date         Author        Comment
** YYYY-MM-DD   <name>        <reason for change>
** =============================================================================
Additional version control information
********************************************************************************
 CCASE_USER    = "Kumar"
 CCASE_VERSION = "\main\8"
***C*E*************************************************************************/


#ifndef __SRAM_TEST_H
#define __SRAM_TEST_H

/*
** =============================================================================
**                           DEFINITIONS
** =============================================================================
*/

/*
** =============================================================================
**                           TYPES
** =============================================================================
*/

/* test structure for SRAM testing */
typedef struct _SRAM_test
{
   uint_16 Ext_SRAM_Result;
   sint_32  Ext_SRAM_AddrFail;
   uint_16 Int_SRAM_Result;
   sint_32  Int_SRAM_AddrFail;
} SRAM_test_t;

/*
** =============================================================================
**                           GLOBAL DATA
** =============================================================================
*/
extern uint_32      gt_ExtSRAM_WrData;
extern uint_32      gt_IntSRAM_WrData;
extern uint_32      gt_ExtSRAM_RdData;
extern uint_32      gt_IntSRAM_RdData;
extern sint_32      gt_ExtSRAM_Addr;
extern sint_32      gt_IntSRAM_Addr;

extern SRAM_test_t  SRAM_Test;
extern uint_16      SRAM_TestResult;

/*
** =============================================================================
**                           FUNCTION PROTOTYPES
** =============================================================================
*/

extern sint_16 SRAM_IntExtTest(uint_32 Type_of_SRAM);
extern uint_16 SRAM_ArbitrationTest(uint_32 Type_of_SRAM);

/*
** =============================================================================
** FUNCTION-DESCRIPTION
**
** FUNCTION-NAME:  <function_name>
**
** DESCRIPTION:    <description of what the function does>
**
** PARAMETERS:     <par_name_1>    [IN]|[OUT] <description of par_1>
**                 ...
**                 <par_name_n>    [IN]|[OUT] <description of par_n>
**
** RETURN VALUE:   <description of the return value if any>
**
** NOTES:          <any special information>
** =============================================================================
*/


#endif /* protect */
