/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2004 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
*-------------------------------------------------------------------------
*
*   Aware DMT Technology. Proprietary and Confidential.
*
*   40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
*   Phone (781) 276 - 4000
*   Fax   (781) 276 - 4001
*
*   RMedleyMsg2TxF_VDSL2.c
*
*   This file contains the RT state function to transmit Medley state messages.
*
*
*-------------------------------------------------------------------------
*/

#include "common.h"
#include "gdata.h"
#include "ModulateSocMessages.h"
#include "vdsl_state.h"
#include "states.h"
#include "OTrainingTxF.h"
#include "ORTrainingRxF.h"
#include "fifo.h"
#include "DSLEngin.h"
#include "socmessage.h"
#include "InitShowTimeTx.h"
#include "vdsl_xception.h"
#include "RTrainingTxF.h"

/*^^^
 *------------------------------------------------------------------------
 *
 *  Name : RMedleyMsg2TxF_VDSL2
 *
 *   This function is the RT state function to transmit Medley state messages.
 *
 *  Prototype:  void RMedleyMsg2TxF_VDSL2(void)
 *
 *  Input Arguments:
 *
 *  Output Arguments:
 *
 *   Return:
 *      None
 *
 *  Global Variables Used:
 *      gs_TxState -- (I) TX state
 *      gs_TxSubState -- (I/O) TX substate
 *      gl_TxSymbolCount -- (I) TX state symbol count
 *      gs_TxSubStateCnt -- (I/O) TX substate count
 *      gs_FormMsgFlag -- (I/O) flag to indicate if forming message is done or not
 *      gs_TxHDLCMsgState -- (I/O) the TX HDLC message handler substate
 *      gs_UpdateTxMsgIdxFlag -- (O) flag to indicate if the TX message index should be updated or not
 *      gs_TxGain -- (I) TX output tone gain level
 *      gs_TxNumBytesPerSymbol -- (I) the number of message bytes modulated to a symbol
 *  Notes:
 *
 *------------------------------------------------------------------------
 *^^^
 */

void RMedleyMsg2TxF_VDSL2(void)
{
   RMedleyMsgHandler();
}
