/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2004 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _FDQHANDLER_H_
#define _FDQHANDLER_H_

/*
 *------------------------------------------------------------------------
 *
 *   Aware DMT Technology. Proprietary and Confidential.
 *
 *   40 Middlesex Turnpike, Bedford, MA 01730-1413
 *   Phone (781) 276 - 4000
 *   Fax   (781) 276 - 4001
 *
 *   fdqhandler.h
 *
 *   This file declares the function prototypes from FdqHandler.c
 *
 *------------------------------------------------------------------------
 */
// FDQ state machine states
#define FDQ_TRAIN_INIT          (0)
#define FDQ_SETUP               (1)
#define FDQ_WAIT_FOR_HW_SET     (2)
#define FDQ_PRE_ACCUM           (3)
#define FDQ_ACCUM               (4)
#define FDQ_TRAIN               (5)
#define FDQ_LOAD                (6)
#define FDQ_NEXT_TONEGROUP      (7)
#define FDQ_TRAIN_DONE          (8)

// function prototype
void FdqHandler(void);

// Defines for variable "gs_FDQTrainType"
#define COARSE_FDQ_TRAIN         (0)
#define FINE_TUNE_FDQ_TRAIN      (1)
#define MEDLEY_FDQ_TRAIN         (2)
#define MEDLEY_FDQ_TRAIN_ONEPASS (3)

// Defines for variable "gs_FDQTrainTypeCntrlFlag"
#define FDQ_TRAIN_TYPE_DEFAULT             0x00
#define FDQ_TRAIN_TYPE_MEDLEY_ONEPASS      0x01
#define FDQ_TRAIN_TYPE_COARSE_ONLY         0x02
#define FDQ_TRAIN_TYPE_FINE_TUNE_ONLY      0x04
#define FDQ_TRAIN_TYPE_FINE_TUNE_ALL_TONE  0x08

#endif // _FDQHANDLER_H_
