/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2007 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
*-------------------------------------------------------------------------------
*
*   Aware DMT Technology. Proprietary and Confidential.
*
*   40 Middlesex Turnpike, Bedford, MA 01730-1413
*   Phone (781) 276 - 4000
*   Fax   (781) 276 - 4001
*
*   filename: Framing_VDSL2.h
*
*   Header file for Framing_VDSL2.c.
*
*-------------------------------------------------------------------------------
*/

#ifndef _FRAMING_VDSL2_H
#define _FRAMING_VDSL2_H

// function prototypes
extern int16 ComputeCWSize(VDSL2Config_t *pt_Config, int16 s_lp);
extern void Compute_PERBp(VDSL2Config_t *pt_Config, int16 s_lp, int16 s_NumTones);
extern void Compute_VDSL2Framing(VDSL2Config_t *pt_Config, BC_LP_TPS_Map_t *pt_TPS_Map, int16 *s_PMDFramesPerIBStructure);
extern int16 GetFifoReadWriteStep(int16 s_D, int16 s_I);
extern void ComputeRates(uint32 ul_Lp, uint16 us_CWSize, uint16 us_Rp, uint16 us_Gp, uint16 us_Mp, uint16 us_Tp, int16 s_fs, int32 *pl_OHRate, int32 *pl_NetRate);
extern void ComputeRatesFS6(int16 s_Path, VDSL2Config_t *pt_Config, int32 *pl_NetRate);
extern void ComputeDelay(VDSL2Config_t *pt_Config, int16 s_lp, uint16 *pus_delay);
extern int16 ComputeSymbolRate(int16 s_NumTones, int16 s_CELength);
// XDSRTFW-442: Feature_All_All_All_All_Vdsl2Sra [Start]
uint32 BinarySearch(FlagT ft_FindMax, uint32 ul_Cnstrnt1, uint32 ul_Cnstrnt2, uint32 ul_start, uint32 ul_end, uint32 ul_default);
extern void ComputeFramingConstraints(void);
extern int32 Calc_DsNDR_DsReTx(int16 s_Nfec, int16 s_Rp, uint32 ul_Lp, int16 s_fs);
// XDSRTFW-442: Feature_All_All_All_All_Vdsl2Sra [End]
#endif // _FRAMING_VDSL2_H
