/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2005 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _HYBRIDTRAININGHANDLER_H_
#define _HYBRIDTRAININGHANDLER_H_

/*
 *------------------------------------------------------------------------
 *
 *   Aware DMT Technology. Proprietary and Confidential.
 *
 *   40 Middlesex Turnpike, Bedford, MA 01730-1413
 *   Phone (781) 276 - 4000
 *   Fax   (781) 276 - 4001
 *
 *   HybridTrainingHandler.h
 *
 *   This file declares the function prototypes from HybridTrainingHandler.c
 *
 *------------------------------------------------------------------------
 */
#include "typedef.h"

// Hybrid training state machine states
#define HYBRID_TRAINING_INIT                (1)
#define HYBRID_TRAINING_PGA                 (2)
#define HYBRID_TRAINING_SET_HYBRID          (3)
#define HYBRID_TRAINING_WAIT_FOR_HYBRID_SET (4)
#define HYBRID_TRAINING_NEXT_HYBRID         (5)
#define HYBRID_TRAINING_FDQ                 (6)
#define HYBRID_TRAINING_SNR                 (7)
#define HYBRID_TRAINING_METRIC              (8)
#define HYBRID_TRAINING_PICK_BEST_HYBRID    (9)
#define HYBRID_TRAINING_RESTORE             (10)
#define HYBRID_TRAINING_DONE                (11)
#define HYBRID_TRAINING_PGA_PLLREFAVG       (12)
#define HYBRID_TRAINING_ECHOPOW             (13)

// function prototype
void HybridTrainingHandler(void);

#endif   // _HYBRIDTRAININGHANDLER_H_
