/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2005 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
*-------------------------------------------------------------------------------
*
*   Aware DMT Technology. Proprietary and Confidential.
*
*   40 Middlesex Turnpike, Bedford, MA 01730-1413
*   Phone (781) 276 - 4000
*   Fax   (781) 276 - 4001
*
*   filename: MfdqHandler_b.h
*
*   Header file for MfdqHandler_b.c.
*
*-------------------------------------------------------------------------------
*/

#ifndef _MFDQHANDLER_B_H
#define _MFDQHANDLER_B_H

void BgInitMfdqVars(void);
void SelectMfdqTones(void);
void BgAccumCovarMatrix(void);
void BgCalcMfdqCoef(void);
int16 CalcMfdqCoef(int16 s_tidx, int16 *psa_MfdqCoef);
int16 GetUpScaleFactor(int32 la_Hi, int32 la_Lo, int16 s_acc_rsh);
FloatG ConvMfdqStat(int32 l_hi, int16 s_hi_rsh, int32 l_lo, int16 s_lo_rsh, int16 s_acc_rsh);
void ComplexMultFloat32(FloatG *pfa_Z, FloatG *pfa_X, FloatG *pfa_Y, FlagT ft_conj_Y);
void CalcComplexLinearEq3x3(FloatG *pfa_R, FloatG *pfa_P, FloatG *pfa_W);

#define mAcc48(pl_Acc48H, pl_Acc48L, l_Acc) { \
   *(pl_Acc48L) += ((l_Acc) & 0x0000FFFF); \
   *(pl_Acc48H) += ((l_Acc) >> 16); \
}

#endif // _MFDQHANDLER_B_H
