/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2005 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _MODEMMONITOR_H_
#define _MODEMMONITOR_H_

/*
 *------------------------------------------------------------------------
 *
 *   Aware DMT Technology. Proprietary and Confidential.
 *
 *   40 Middlesex Turnpike, Bedford, MA 01730-1413
 *   Phone (781) 276 - 4000
 *   Fax   (781) 276 - 4001
 *
 *   ModemMonitor.h
 *
 *   This file declares the function prototypes from ModemMonitor.h
 *
 *------------------------------------------------------------------------
 */

#include "gdata.h"

extern int16 gs_ModemMonitorState;
extern int16 gs_AutoMsgHandlerState;

/* =============================================== */
/* ModemMonitor substates                    */
/* =============================================== */
#define MODEM_MONITOR_IDLE                        (-1)
#define MODEM_MONITOR_AUTO_MSG_HANDLER             (0)
#define MODEM_MONITOR_TR1_RESET_HANDLER            (1)

/* =============================================== */
/* AutoMsgHandler substates                     */
/* =============================================== */
#define CHECK_MODEM_MACRO_STATE                      0
#define SUBMIT_MODEM_STAT_FAILURE_INFO              10
#define CHECK_AUTOMESSAGE_ON_LINE_FAILURES_NE      100
#define CHECK_AUTOMESSAGE_ON_LINE_FAILURES_FE      200
#define CHECK_FAILSTATE_ON_LINE_FAILURES_NE        300
#define CHECK_FAILSTATE_ON_LINE_FAILURES_FE        400
#define CHECK_TR1_ROLLOVER                         500
#define CHECK_TR1_ALARM                            600
#define CHECK_FEDATASEND                           700
#define SUBMIT_AUTO_MSG                            800
#define CHECK_CLEAREOCSTAT                         900
#define CHECK_CLEAREOCMSG                         1000
#define CHECK_US_SHOW_OLR_EVENT                   1100
#define CHECK_DS_SHOW_OLR_EVENT                   1200
#define SEND_ERBMSG                               1300
#define CHECK_TC_TYPE                             1400

// ===============================================
// Function prototypes
// ===============================================
void ModemMonitor(void);

#endif   // _MODEMMONITOR_H_
