/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2006 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _ORTRAININGRXF_H
#define _ORTRAININGRXF_H

/**********************************************************************
 *
 * Aware DMT Technology. Proprietary and Confidential.
 *
 * ADDRESS:          40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
 * TELEPHONE:        781.276.4000
 * FAX:              781.276.4001
 * WEB:              http://www.aware.com
 *
 * FILE:             ORTrainingRxF.h
 * DESCRIPTION:      Header file containing functions that implement
 *                   states in the Transceiver Training phase of
 *                   Initilization.
 *
 **********************************************************************/

/**********************************************************************
 * FUNCTIONS
 **********************************************************************/

//VDSL2 state functions
void ORTrainRxF_VDSL2(void);
void ORMsg1RxF_VDSL2(void);
void ORMsg1RxF_VDSL2_Bridge(void);
void ORPSynchro1RxF_VDSL2(void);
void ORPLineprobeRxF_VDSL2(void);
void ORPPeriodic1RxF_VDSL2(void);
void ORPSynchro2RxF_VDSL2(void);
void ORUpdateRxF_VDSL2(void);
void ORPrmRxF_VDSL2(void);
void ORPSynchro3RxF_VDSL2(void);
void ORPTrain1RxF_VDSL2(void);
void ORPTrain1RxF_VDSL2_Bridge(void);
void ORPSynchro4RxF_VDSL2(void);
void NextRxTrainingState(void);
void ORPTeqRxF_VDSL2(void);
void ORPQuiet3RxF_VDSL2(void);
void ORPQuiet3RxF_VDSL2_DecTrain(void);
void ORPEctRxF_VDSL2(void);
void ORPPeriodic2RxF_VDSL2(void);
void ORTaUpdateRxF_VDSL2(void);
void ORAckRxF_VDSL2(void);
void ORPSynchro5RxF_VDSL2(void);
void ORPMedleyRxF_VDSL2_Bridge(void);
void ORPMedleyRxF_VDSL2(void);
void MedleyMsgCheckRxTimer(void);
void ORMsg2RxF_VDSL2(void);
void ORTpsAckRxF_VDSL2(void);
void ORPmsRxF_VDSL2(void);
void ORPmdRxF_VDSL2(void);
void ORPSynchro6RxF_VDSL2(void);
void ORShowtimeRxF_VDSL2(void);

//Diagnostic mode specific state functions
void ORPSynchro6RxF_VDSL2Diag(void);
void ORMsgLdRxF_VDSL2(void);
void ORPSynchro7RxF_VDSL2Diag(void);
void DiagDoneStateFunc(void);
#endif /* _ORTRAININGRXF_H */
