/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2006 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _OTRAININGTXF_H
#define _OTRAININGTXF_H

/**********************************************************************
 *
 * Aware DMT Technology. Proprietary and Confidential.
 *
 * ADDRESS:          40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
 * TELEPHONE:        781.276.4000
 * FAX:              781.276.4001
 * WEB:              http://www.aware.com
 *
 * FILE:             OTrainingTxF.h
 * DESCRIPTION:      Header file containing functions that implement
 *                   states in the VDSL CO Transceiver Training phase
 *                   of initialization.
 *
 **********************************************************************/

/**********************************************************************
 * FUNCTIONS
 **********************************************************************/


//VDSL2 state functions
void OSignatureTxF_VDSL2(void);
void OSignatureTxF_VDSL2_Bridge(void);
void OPSynchro1TxF_VDSL2(void);
void OPQuietPilot1TxF_VDSL2(void);
void OPPeriodic1TxF_VDSL2(void);
void OPSynchro2TxF_VDSL2(void);
void OPDiscovery2TxF_VDSL2(void);
void OPSynchro3TxF_VDSL2(void);
void OPTrain1TxF_VDSL2(void);
void OPTrain1TxF_VDSL2_Bridge(void);
void OPSynchro4TxF_VDSL2(void);
void OPPilot2TxF_VDSL2(void);
void OPEctTxF_VDSL2(void);
void OPEctTxF_VDSL2_DecTrain(void);
void NextTxTrainingState(void);
void OPTeqTxF_VDSL2(void);
void OPPilot3TxF_VDSL2(void);
void OPPeriodic2TxF_VDSL2(void);
void OPTrain2TxF_VDSL2(void);
void OPSynchro5TxF_VDSL2(void);
void OPMedleyTxF_VDSL2_Bridge(void);
void OPMedleyTxF_VDSL2(void);
void OMedleyMsgHandler(void);
void OPSynchro6TxF_VDSL2(void);
void OShowtimeTxF_VDSL2(void);

//Diagnostic mode specfic state functions
void OPSynchro6TxF_VDSL2Diag(void);
void OPTrain3TxF_VDSL2Diag(void);
void OPSynchro7TxF_VDSL2Diag(void);
void DiagDoneStateFunc(void);
#endif /* _OTRAININGTXF_H */
