/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2004 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _PSD_B_H
#define _PSD_B_H

/**********************************************************************
 *
 * Aware DMT Technology. Proprietary and Confidential.
 *
 * ADDRESS:          40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
 * TELEPHONE:        781.276.4000
 * FAX:              781.276.4001
 * WEB:              http://www.aware.com
 *
 * FILE:             psd.h
 * DESCRIPTION:      Header file for psd_b.c.
 *
 **********************************************************************/

/**********************************************************************
 * FUNCTIONS
 **********************************************************************/
void BgPsdCalc(void);
void PsdCalc(int32 *pla_NoisePower, int16 *psa_snr, int16 s_first_chan, int16 s_last_chan);
void BgPsdAnalysis(void);
void PsdAnalysis(void);
void DMAtoSDRAM_PerTone(uint8 uc_Page);         // XDSLRTFW-3344 (Start_End)

int32 accum_power(int32 l_tone_pow, int16 s_precision);
void get_float_representation(int32 l_fixed, int16* mantissa, int16* exponent);
void float_macc(int16 s_mant_a_1,int16 s_exp_a_1,int16 s_mant_a_2,int16 s_exp_a_2,
            int16 s_mant_b_1,int16 s_exp_b_1,int16 s_mant_b_2,int16 s_exp_b_2,
            int32* l_mant_result,int16* s_exp_result);

void ApplyRxPathPsdCorrection(int16 *psa_PsdIn, int16 *psa_PsdOut, int16 hlogFlag);
// XDSLRTFW-487_VR9_VRX318_VDSL2_All_AELEM_Support (START)
void GenerateRxPathPsdCorrectionVector(void);

#endif /* _PSD_B_H */

