/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _ROPVECTOR1HANDLER_H_
#define _ROPVECTOR1HANDLER_H_

/*
 *------------------------------------------------------------------------
 *
 *   ROPVECTOR1Handler.h
 *
 *   This file declares the function prototypes from PGAHandler.c
 *
 *------------------------------------------------------------------------
 */
#include "typedef.h"

// ROPVector1 handler state machine states
#define R_O_P_VECTOR1_INIT             (1)
#define R_O_P_VECTOR1_READ_POWER       (2)
#define R_O_P_VECTOR1_COMPUTE_POWER       (3)
#define R_O_P_VECTOR1_FRMALGN_INIT        (4)
#define R_O_P_VECTOR1_FRMALGN          (5)
#define R_O_P_VECTOR1_FRAMEALIGNMENT_RESET   (6)
#define R_O_P_VECTOR1_DONE                   (7)
#define R_O_P_VECTOR_1_X_DETECTED         (8)

// ROPSynchroV2_VDSL2 state machine state
#define R_O_P_SYNCHRO_V2_RX_INIT            (0)
#define R_O_P_SYNCHRO_V2_RX_DETECT          (1)
#define R_O_P_SYNCHRO_V2_DONE             (2)

void ROPVector1Handler(void);
void ROPVector1Detector(void);

void ROPSynchroV2_VDSL2(void);

#endif   // _ROPVECTOR1HANDLER_H_
