/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2006 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _ROTRAININGRXF_H
#define _ROTRAININGRXF_H

/**********************************************************************
 *
 * Aware DMT Technology. Proprietary and Confidential.
 *
 * ADDRESS:          40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
 * TELEPHONE:        781.276.4000
 * FAX:              781.276.4001
 * WEB:              http://www.aware.com
 *
 * FILE:             ROTrainingRxF.h
 * DESCRIPTION:      Header file containing functions that implement
 *                   states in the Transceiver Training phase of
 *                   Initilization.
 *
 **********************************************************************/

/**********************************************************************
 * FUNCTIONS
 **********************************************************************/



//VDSL2 state functions
void MedleyTrainRxF(void);
void ROTrainRxF_VDSL2(void);
void ROSignatureRxF_VDSL2(void);
void ROSignatureRxF_VDSL2_Bridge(void);
void ROPSynchro1RxF_VDSL2(void);
void ROPQuietPilot1RxF_VDSL2(void);
void ROPPeriodic1RxF_VDSL2(void);
void ROPSynchro2RxF_VDSL2(void);
void ROUpdateRxF_VDSL2(void);
void ROPrmRxF_VDSL2(void);
void ROAckRxF_VDSL2(void);
void ROPSynchro3RxF_VDSL2(void);
void ROPTrain1RxF_VDSL2(void);
void ROPTrain1RxF_VDSL2_Bridge(void);
void ROPSynchro4RxF_VDSL2(void);
void NextRxTrainingState(void);
void ROPPilot2RxF_VDSL2(void);
void ROPEctRxF_VDSL2(void);
void ROPTeqRxF_VDSL2(void);
void ROPPilot3RxF_VDSL2(void);
void ROPPeriodic2RxF_VDSL2(void);
void ROTaUpdateRxF_VDSL2(void);
void ROPSynchro5RxF_VDSL2(void);
void MedleyMsgCheckRxTimer(void);
void ROMsg1RxF_VDSL2(void);
void ROPMedleyRxF_VDSL2_Bridge(void);
void ROPMedleyRxF_VDSL2(void);
void ROTpsRxF_VDSL2(void);
void ROPmsRxF_VDSL2(void);
void ROPmdRxF_VDSL2(void);
void ROPmdAckRxF_VDSL2(void);
void ROPSynchro6RxF_VDSL2(void);
void ROShowtimeRxF_VDSL2(void);

//diagnostic mode specific state functions
void ROPSynchro6RxF_VDSL2Diag(void);
void ROMsgLdRxF_VDSL2(void);
void ROPSynchro7RxF_VDSL2Diag(void);
void DiagDoneStateFunc(void);

#endif /* _ROTRAININGRXF_H */
