/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2006 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
/*
 *------------------------------------------------------------------------
 *
 *   Aware DMT Technology. Proprietary and Confidential.
 *
 *   40 Middlesex Turnpike, Bedford, MA 01730-1413 USA
 *   Phone (781) 276 - 4000
 *   Fax   (781) 276 - 4001
 *
 *   SharedFuncs.h
 *
 *   This is the header file for SharedFuncs.c
 *------------------------------------------------------------------------
 */

//SharedFuncs.c
extern int16 ClusterIndex(int16 s_channel);
extern void BgSelectRxMsgDecodeTones(void);
extern void SelectBand(int16 *psa_SnrBuf, int16 s_SelectBandSize, int16 s_SnrThresh, int16 *ps_SelectBandStart, int16 *ps_AvgSnr);
extern void SavePostTimeAdvanceInfo(void);
extern void SavePreTimeAdvanceInfo(void);
extern int16 CalcTxRxFrameOffset(void);

extern void BgStreamRxEchoPsd(void);

// AddPsdBrkpt.c
extern FlagT AddPsdBrkpt(int16 s_toneIdx, int16 s_attenLevel, PSDDescriptorTable_t *pt_PSDDescOut, int16 s_MaxPsdPoints);

// BgReconfigBandPlan.c
extern void ReconfigBandPlan(void);
extern void BgReconfigBandPlan(void);
extern void VDSL2_BandControlGet(uint8 uc_UpdateSelect);  // Fill band control information for status CMVs!

// Clear/Set tones in supported toneset
extern void ClearGhsTonesInSupportedSet(void);
extern void ClearSetPilotTonesInSupportedSet(int16 s_Selection);

// CheckForBandOverlap.c
extern FlagT CheckForBandOverlap(void);

// PSDShaping.c
int16 PSDCompensation(int16 s_ToneIdx, uint16 us_NoOfCompBreakPoint, PSDCompDescriptorTable_t *pt_PSDDesc);
extern void GetAdjacentBreakpts(int16 s_brkptIdxIn, int16 s_NumBrkptsIn, PSDRecord_t *pt_PSDRecIn, int16 s_minToneIdxIn, int16 s_maxToneIdxIn, int16 *ps_leftToneIdxOut, int16 *ps_leftToneAttenLevelOut, int16 *ps_rightToneIdxOut, int16 *ps_rightToneAttenLevelOut);
extern void GetAdjacentBreakpts2(int16 s_brkptIdxIn, int16 s_NumBrkptsIn, PSDCompRecord_t *pt_PSDRecIn, int16 s_minToneIdxIn, int16 s_maxToneIdxIn, int16 *ps_leftToneIdxOut, int16 *ps_leftToneAttenLevelOut, int16 *ps_rightToneIdxOut, int16 *ps_rightToneAttenLevelOut); //  //XDSLRTFW-2260 (Start_End)
extern int16 CalcAttenLevel(int16 s_toneIdx, int16 s_leftToneIdx, int16 s_leftToneAttenLevel, int16 s_rightToneIdx, int16 s_rightToneAttenLevel);
extern int16 ComputeLinearPSD(int16 s_ToneIdx, PSDDescriptorTable_t *pt_PSDDesc);

// InitTrainState.c
void InitTrainTxF(void);
void InitTrainRxF(void);
