/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2003 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _SNRHANDLER_H_
#define _SNRHANDLER_H_

/*
 *------------------------------------------------------------------------
 *
 *   Aware DMT Technology. Proprietary and Confidential.
 *
 *   40 Middlesex Turnpike, Bedford, MA 01730-1413
 *   Phone (781) 276 - 4000
 *   Fax   (781) 276 - 4001
 *
 *   SnrHandler.h
 *
 *   This file declares the function prototypes from SnrHandler.c
 *
 *------------------------------------------------------------------------
 */
#include "typedef.h"

// SNR state machine states
#define SNR_INIT        (0)
#define  SNR_SETUP         (1)
#define SNR_WAIT_FOR_HW_SET   (2)
#define  SNR_ACCUM         (3)
#define SNR_NEXT_TONEGROUP  (4)
#define  SNR_CALC_DONE     (5)

#define SNR_MEDLEY_SAVE_FDQ         (6)
#define SNR_MEDLEY_ROTATE_FDQ       (7)
#define SNR_MEDLEY_LOAD_ROTATED_FDQ (8)
#define SNR_MEDLEY_WAIT_FOR_HW_SET  (9)
#define SNR_MEDLEY_RESTORE_FDQ      (10)

// function prototype
void BgSnrMedleyRestoreFdq(void);
void BgSnrInit(void);
void SnrHandler(void);

#endif   // _SNRHANDLER_H_
