/* **COPYRIGHT******************************************************************
    INTEL CONFIDENTIAL
    Copyright (C) 2017 Intel Corporation
    Copyright (C), 1994-2003 Aware Inc. All Rights Reserved.
******************************************************************COPYRIGHT** */
/* **DISCLAIMER*****************************************************************
    The source code contained or described herein and all documents related
    to the source code ("Material") are owned by Intel Corporation or its
    suppliers or licensors. Title to the Material remains with Intel
    Corporation or its suppliers and licensors. The Material may contain
    trade secrets and proprietary and confidential information of Intel
    Corporation and its suppliers and licensors, and is protected by
    worldwide copyright and trade secret laws and treaty provisions. No part
    of the Material may be used, copied, reproduced, modified, published,
    uploaded, posted, transmitted, distributed, or disclosed in any way
    without Intel's prior express written permission.

    No license under any patent, copyright, trade secret or other
    intellectual property right is granted to or conferred upon you by
    disclosure or delivery of the Materials, either expressly, by
    implication, inducement, estoppel or otherwise. Any license under
    such intellectual property rights must be express and approved by
    Intel in writing.
*****************************************************************DISCLAIMER** */
#ifndef _DATATYPE_H
#define _DATATYPE_H

/****************************************************************************
;  Aware DMT Technology. Proprietary and Confidential.
;
;   40 Middlesex Turnpike, Bedford, MA 01730-1413
;  Phone (781) 276 - 4000
;   Fax   (781) 276 - 4001
;
;
;  File Name: datatype.h
;
;  This file contains type definitions.
'
*****************************************************************************/

#include <stdio.h>

//Variable type definitions
typedef signed char    int8;     // prefix c
typedef signed short   int16;    // prefix s
typedef signed int     int32;    // prefix l

typedef unsigned char  uint8;    // prefix uc
typedef unsigned short uint16;      // prefix us
typedef unsigned int   uint32;      // prefix ul
typedef unsigned long long   uint64;      // prefix ull

typedef unsigned char  FlagT;    // prefix ft
typedef char           string[80+1]; // prefix ca

typedef unsigned int Float32;
typedef double float64;          // prefix d

typedef void (BkgdFunction)(void);
typedef void (*PtrToBkgdFunc)(void);

#ifdef FLOAT_IN_SW
typedef Float32 FloatG;
#else
typedef double FloatG;
#endif // FLOAT_IN_SW


// 8-bit signed type.
typedef signed char int8_t;
//     8-bit unsigned type. */
typedef unsigned char uint8_t;

// 16-bit signed type. */
typedef signed short int16_t;
//     16-bit unsigned type. */
typedef unsigned short uint16_t;

//    32-bit signed type. */
typedef signed long int int32_t;
//    32-bit unsigned type. */
typedef unsigned long int uint32_t;
//    64-bit signed type.
typedef signed long long int int64_t;
//   64-bit unsigned type.

typedef unsigned long long int uint64_t;


#endif //_DATATYPE_H
